<?php
// $Id: bookmarks.html.php, v2.8_0b (25.01.2010) 14:16:37 DJesus Exp $
/**
* Content code
* @package Mambo Open Source
* @ Mambo Open Source is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @ Original version: Richard Masse
* @ version $Revision: 2.8 $
**/

defined( '_JEXEC' ) or die( 'Restricted access' );

require_once( JPATH_SITE."/includes/HTML_toolbar.php" );


class HTML_bookmarks {

  /**
   * Function to write the footer
   */
  function _footer($colspan=1) {
     global $_VERSION;

     echo '<!-- Footer & Copyrights -->'."\n";
     $showcopy = mosBookmarksTools::getPref(-1,'params','displaycopyrights', '1');
     if ($showcopy) {
        echo '  <tr align="center"><td class="small" colspan="'.$colspan.'"><br /><b>';
        echo ' <a href="http://www.tegdesign.ch/" target="_blank" title="Bookmarks Official Project Repository">Bookmarks</a>';
        if ($showcopy!='2') {
           echo '&nbsp;</b>' .mosBookmarks::getVersion(). '<b>';
	}
	echo '&nbsp;<a href="http://www.tegdesign.ch/" target="_blank" title="Copyright TEGDesign.ch">&copy; 2010 TEGDesign</a></b></td></tr>'."\n";
     }
  }




  function ShowCatsHoriz ($option, $catid, &$categories, $Itemid, &$params) {

    $nbcols = intval( $params->catnbcolumns );

    $ii = 0;
    $col = 0;

    if ($categories) {    // Something to display ???

       $items = 0;

       foreach ($categories as $cat) {
         if ($cat->parent == $categories[0]->parent) {
            $items++;
         }  // Counts only cats of the 1st level
       }
       $nbrows = ceil($items / $nbcols);

       $catlevel = 0;
       $line=0;
       $catitem = 0;
       $item = 0;
       $subcats = 0;

       // *** Loading Bots if requested
       if ($params->botsoncatlistdesc ) {  // Need to process Bots ?
          //$_MAMBOTS->loadBotGroup( 'content' );  // Load published Bots from "Content" folder
          JPluginHelper::importPlugin( 'content' );  // Load published Bots from "Content" folder
       }

       if ( $items > 0 ) {    // Some cats to display

          echo '  <tr><td>'."\n";
          echo '    <table class="contentpane" border="0" cellspacing="0" cellpadding="' .$params->paddingcategories. '" width="100%">'."\n";

          while ( $line < $nbrows ) {
              $col=0;
              echo '      <tr>'."\n";    // new line

              while ( $col < $nbcols ) {

                 if ( $item < $items ) {     // This is a cell with a content

                    $jj = 0;
                    for ($ii=0; $ii < count($categories); $ii++) {  // determine Cat for the grid position
                       if ($categories[$ii]->parent == $categories[0]->parent ) { // Count only cats of the 1st level
                          if ($jj == $item) {
                             $catitem = $ii;
                             break;
                          }
                          $jj++;
                       }
                    }

                    $cat = $categories[$catitem];

                    echo '        <td width="' .floor(100/$nbcols). '%" valign="top">';    //   New Cell    nowrap="nowrap"

                    if ( $cat->numlinks != 0 || $cat->numchild != 0 ) {
                       echo '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=".$params->mode."&catid=".$cat->catid."&navstart=".$params->navstart."&search=".$params->search). '"'.mosBookmarksTools::cssClass($params->csscategories).' title="' .htmlspecialchars($cat->name, ENT_NOQUOTES);
                       if ($params->catshowcount) {
                          echo '&nbsp;(';
                          echo ($params->catshowcount == 1 || $params->catshowcount == 2) ? $cat->numlinks." "._BMU_BOOKMARKS : "";
                          echo ($params->catshowcount == 1) ? ' + ' : "";
                          echo ($params->catshowcount == 1 || $params->catshowcount == 3) ? $cat->numchild." "._BMU_SUBCATEGORIES : "";
                          echo ')';
                       }
                       echo '">';
                    }

                    if ($params->catlistmode > -1) {
                       if ($params->catlistmode && $cat->icon) {
                          $iconurl = JUri::base(true). '/images/stories/' .$cat->icon;
                          echo '<img src="' .$iconurl. '" border="0" />&nbsp;';
                       } else {
                          echo mosBookmarksTools::imageArrow();
                       }
                    }

                    echo htmlspecialchars($cat->title, ENT_NOQUOTES);

                    if ( $cat->numlinks != 0 || $cat->numchild != 0 ) {
                         echo '</a>';
                    }

                    if ($params->catshowcount) {
                       echo '&nbsp;<span class="small">(';
                       echo ($params->catshowcount == 1 || $params->catshowcount == 2) ? $cat->numlinks : "";
                       echo ($params->catshowcount == 1) ? '+' : "";
                       echo ($params->catshowcount == 1 || $params->catshowcount == 3) ? $cat->numchild : "";
                       echo ')</span>';
                    }

                    // *** Display Category Description
                    if ($params->showcatlistdesc && $cat->description) {
                       if ($params->botsoncatlistdesc ) {  // Need to process Bots ?

                          $row->text = $cat->description;    // MosBot only uses field "text" => Need to copy "detail" content ...
                          $row->images = "";                 // MosBot Need to simulate "images" field (must be present, but keep it empty)
                          $row->sectionid = "";              // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
                          $page = 0;                         // MosBot pagination system
                          $prms = "";
                          $bmparams =& new JParameter( $prms );   // Use "$botparms" to avoid overwritting "$params" (from Module)

                          echo '<!-- Bots -->'."\n";
                          // Process the MosBots
                          //$results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
                          $results =  $mainframe->triggerEvent( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );

                          // Update field with processed text
                          $cat->description = $row->text;
                       }
                       echo "<br />\n" . $cat->description;
                    }

                    $catitem++;
                    if ( ($cat->numchild > 0) && ($params->subcatsdisplay > 0)) {  // Need to display Sub-Cats

                       $subcats = 0;
                       echo "<br />\n";

                       while ( ($subcats < $params->subcatsdisplay) && ($subcats < $cat->numchild) && ($categories[$catitem]->parent != $categories[0]->parent) ) {     // it's a Subcat
                            $scat = $categories[$catitem];    // Get Cat
                            if ($params->subcatsorder) {
                               echo ($subcats) ? ",&nbsp;\n" : "\n";
                            } else {
                               echo ($subcats) ? "<br />\n" : "\n";
                            }

                            if ($params->catlistmode > -1) {
                               if ($params->catlistmode==2 && $scat->icon) {
                                  $iconurl = JUri::base(true). '/images/stories/' .$scat->icon;
                                  echo '<img src="' .$iconurl. '" border="0" />&nbsp;';
                               } else {
//                                echo mosBookmarksTools::imageArrow();
                               }
                            }

                            if ( ($scat->numlinks + $scat->numchild) == 0) {
                                 echo ''.htmlspecialchars($scat->title, ENT_NOQUOTES).'';
                            } else {
                                 echo '          <a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=".$params->mode."&catid=".$scat->catid."&navstart=".$params->navstart."&search=".$params->search). '"'.mosBookmarksTools::cssClass($params->csssubcategories).' title="' .htmlspecialchars($scat->name, ENT_NOQUOTES);
                                 if ($params->catshowcount) {
                                    echo '&nbsp;(';
                                    echo ($params->catshowcount == 1 || $params->catshowcount == 2) ? $scat->numlinks." "._BMU_BOOKMARKS : "";
                                    echo ($params->catshowcount == 1) ? '+' : "";
                                    echo ($params->catshowcount == 1 || $params->catshowcount == 3) ? $scat->numchild." "._BMU_SUBCATEGORIES : "";
                                    echo ')';
                                 }
                                 echo '">' .htmlspecialchars($scat->title, ENT_NOQUOTES). '</a>';
                            }
                            if ($params->catshowcount) {
                               echo '&nbsp;<span class="small">(';
                               echo ($params->catshowcount == 1 || $params->catshowcount == 2) ? $scat->numlinks : "";
                               echo ($params->catshowcount == 1) ? '+' : "";
                               echo ($params->catshowcount == 1 || $params->catshowcount == 3) ? $scat->numchild : "";
                               echo ')</span>';
                            }

                            // *** Display Sub-Category Description
                            if ($params->showcatlistdesc && $scat->description) {
                               if ($params->botsoncatlistdesc ) {  // Need to process Bots ?

                                  $row->text = $scat->description;    // MosBot only uses field "text" => Need to copy "detail" content ...
                                  $row->images = "";                 // MosBot Need to simulate "images" field (must be present, but keep it empty)
                                  $row->sectionid = "";              // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
                                  $page = 0;                         // MosBot pagination system
                                  $prms = "";
                                  $bmparams =& new JParameter( $prms );   // Use "$botparms" to avoid overwritting "$params" (from Module)

                                  echo '<!-- Bots -->'."\n";
                                  // Process the MosBots
                                  //$results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
                                  $results =  $mainframe->triggerEvent( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );

                                  // Update field with processed text
                                  $scat->description = $row->text;
                               }
                               if (!$params->subcatsorder) {
                                  echo "<br />\n"; // vertical display
                               }
                               echo $scat->description;
                            }

                            $subcats++;
                            $catitem++;
                       }
                       if ( $cat->numchild > $params->subcatsdisplay ) {
                          echo ", ...";
                       }

                    }

                    echo '</td>'."\n";    // close cell
                 }
                 $col++;
                 $item++;
              }
              $line++;
              echo "      </tr>"."\n";
          }
          echo "    </table>"."\n";
          echo "  </td></tr>"."\n";
       }
    }
  }


  function ShowCatsVert ($option, $catid, &$categories, $Itemid, &$params) {

    $nbcols = intval( $params->catnbcolumns );

    $ii = 0;
    $col = 0;

    if ($categories) {    // Something to display ???

       $items = 0;

       foreach ($categories as $cat) {
         if ($cat->parent == $categories[0]->parent) {
            $items++;
         }  // Counts only cats of the 1st level
       }
       $nbrows = ceil($items / $nbcols);

       $catlevel = 0;
       $line=0;
       $catitem = 0;
       $item = 0;
       $subcats = 0;

       // *** Loading Bots if requested
       if ($params->botsoncatlistdesc ) {  // Need to process Bots ?
          //$_MAMBOTS->loadBotGroup( 'content' );  // Load published Bots from "Content" folder
          JPluginHelper::importPlugin( 'content' );  // Load published Bots from "Content" folder
       }

       if ( $items > 0 ) {    // Some cats to display

          echo '  <tr><td>'."\n";
          echo '    <table class="contentpane" border="0" cellspacing="0" cellpadding="' .$params->paddingcategories. '" width="100%">'."\n";

          while ( $line < $nbrows ) {
              $col=0;
              echo '      <tr>'."\n";    // new line

              while ( $col < $nbcols ) {

                 $item = ($col*$nbrows) + $line;  // compute grid position

                 if ( $item < $items ) {     // This is a cell with a content
                    $jj = 0;
                    for ($ii=0; $ii < count($categories); $ii++) {  // determine Cat for the grid position
                       if ($categories[$ii]->parent == $categories[0]->parent ) { // Count only cats of the 1st level
                          if ($jj == $item) {
                             $catitem = $ii;
                             break;
                          }
                          $jj++;
                       }
                    }
                    $cat = $categories[$catitem];

                    echo '        <td width="' .floor(100/$nbcols). '%" valign="top">';    //   New Cell    nowrap="nowrap"

//  echo "[l:$cat->numlinks|c:$cat->numchild|e:$params->showemptycats|s:$params->catshowcount]"; // Debug

                    if ( $params->showemptycats || (!$params->showemptycats && ($cat->numlinks != 0 || $cat->numchild != 0)) ) {
                       echo '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=".$params->mode."&catid=".$cat->catid."&navstart=".$params->navstart."&search=".$params->search). '"'.mosBookmarksTools::cssClass($params->csscategories).' title="' .htmlspecialchars($cat->name, ENT_NOQUOTES);
                       if ($params->catshowcount) {
                          echo '&nbsp;(';
                          echo ($params->catshowcount == 1 || $params->catshowcount == 2) ? $cat->numlinks." "._BMU_BOOKMARKS : "";
                          echo ($params->catshowcount == 1) ? ' + ' : "";
                          echo ($params->catshowcount == 1 || $params->catshowcount == 3) ? $cat->numchild." "._BMU_SUBCATEGORIES : "";
                          echo ')';
                       }
                       echo '">';

                       if ($params->catlistmode > -1) {
                          if ($params->catlistmode && $cat->icon) {
                             $iconurl = JUri::base(true). '/images/stories/' .$cat->icon;
                             echo '<img src="' .$iconurl. '" border="0" />&nbsp;';
                          } else {
                             echo mosBookmarksTools::imageArrow();
                          }
                       }


                       echo htmlspecialchars($cat->title, ENT_NOQUOTES);

                       echo '</a>';
                    }

                    if ($params->catshowcount) {
                       echo '&nbsp;<span class="small">(';
                       echo ($params->catshowcount == 1 || $params->catshowcount == 2) ? $cat->numlinks : "";
                       echo ($params->catshowcount == 1) ? '+' : "";
                       echo ($params->catshowcount == 1 || $params->catshowcount == 3) ? $cat->numchild : "";
                       echo ')</span>';
                    }

                    // *** Display Category Description
                    if ($params->showcatlistdesc && $cat->description) {
                       if ($params->botsoncatlistdesc ) {  // Need to process Bots ?

                          $row->text = $cat->description;    // MosBot only uses field "text" => Need to copy "detail" content ...
                          $row->images = "";                 // MosBot Need to simulate "images" field (must be present, but keep it empty)
                          $row->sectionid = "";              // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
                          $page = 0;                         // MosBot pagination system
                          $prms = "";
                          $bmparams =& new JParameter( $prms );   // Use "$botparms" to avoid overwritting "$params" (from Module)

                          echo '<!-- Bots -->'."\n";
                          // Process the MosBots
                          //$results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
                          $results =  $mainframe->triggerEvent( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );

                          // Update field with processed text
                          $cat->description = $row->text;
                       }
                       echo "<br />\n" . $cat->description;
                    }

                    if ( ($cat->numchild > 0) && ($params->subcatsdisplay > 0)) {  // Need to display Sub-cats

                       $subcats = 0;
                       echo "<br />\n";

                       $catitem++;
                       while ( ($subcats < $params->subcatsdisplay) && ($subcats < $cat->numchild) && ($categories[$catitem]->parent != $categories[0]->parent) ) {     // it's a Subcat
                            $scat = $categories[$catitem];    // Get Cat
                            if ($params->subcatsorder) {
                               echo ($subcats) ? ",&nbsp;\n" : "";
                            } else {
                               echo ($subcats) ? "<br />\n" : "";
                            }

                            if ($params->catlistmode > -1) {
                               if ($params->catlistmode==2 && $scat->icon) {
                                  $iconurl = JUri::base(true). '/images/stories/' .$scat->icon;
                                  echo '<img src="' .$iconurl. '" border="0" />&nbsp;';
                               } else {
   //                               echo mosBookmarksTools::imageArrow();
                               }
                            }

                            if ( (!$params->showemptycats) && (($scat->numlinks + $scat->numchild) == 0 ) ) {
                                 echo ''.htmlspecialchars($scat->title, ENT_NOQUOTES).'';
                            } else {
                                 echo '          <a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=".$params->mode."&catid=".$scat->catid."&navstart=".$params->navstart."&search=".$params->search). '"'.mosBookmarksTools::cssClass($params->csssubcategories).' title="' .htmlspecialchars($scat->name, ENT_NOQUOTES);
                                 if ($params->catshowcount) {
                                    echo '&nbsp;(';
                                    echo ($params->catshowcount == 1 || $params->catshowcount == 2) ? $scat->numlinks." "._BMU_BOOKMARKS : "";
                                    echo ($params->catshowcount == 1) ? ' + ' : "";
                                    echo ($params->catshowcount == 1 || $params->catshowcount == 3) ? $scat->numchild." "._BMU_SUBCATEGORIES : "";
                                    echo ')';
                                 }
                                 echo '">' .htmlspecialchars($scat->title, ENT_NOQUOTES). '</a>';
                            }
                            if ($params->catshowcount) {
                               echo '&nbsp;<span class="small">(';
                               echo ($params->catshowcount == 1 || $params->catshowcount == 2) ? $scat->numlinks : "";
                               echo ($params->catshowcount == 1) ? '+' : "";
                               echo ($params->catshowcount == 1 || $params->catshowcount == 3) ? $scat->numchild : "";
                               echo ')</span>';
                            }
                            // *** Display Sub-Category Description
                            if ($params->showcatlistdesc && $scat->description) {
                               if ($params->botsoncatlistdesc ) {  // Need to process Bots ?

                                  $row->text = $scat->description;    // MosBot only uses field "text" => Need to copy "detail" content ...
                                  $row->images = "";                 // MosBot Need to simulate "images" field (must be present, but keep it empty)
                                  $row->sectionid = "";              // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
                                  $page = 0;                         // MosBot pagination system
                                  $prms = "";
                                  $bmparams =& new JParameter( $prms );   // Use "$botparms" to avoid overwritting "$params" (from Module)

                                  echo '<!-- Bots -->'."\n";
                                  // Process the MosBots
                                  //$results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
                                  $results =  $mainframe->triggerEvent( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );

                                  // Update field with processed text
                                  $scat->description = $row->text;
                               }
                               echo "<br />\n" . $scat->description;
                            }

                            $subcats++;
                            $catitem++;
                       }
                       if ( $cat->numchild > $params->subcatsdisplay ) {
                          echo ", ...";
                       }

                    }

                    echo '</td>'."\n";    // close cell
                    $col++;

                 } else {
                    $col++;
                 }
              }
              $line++;
              echo "      </tr>"."\n";
          }

          echo "    </table>"."\n";
          echo "  </td></tr>"."\n";

       }
    }
  }


  function ShowCatsTree($option, $catid, &$categories, $Itemid, &$params) {
    global $mainframe;

    $nbcols = intval( $params->catnbcolumns );

    $ii = 0;
    $col = 0;

    if ($categories) {    // Something to display ???

       echo '  <tr><td>'."\n";
       echo '    <table class="contentpane" border="0" cellspacing="0" cellpadding="' .$params->paddingcategories. '" width="100%">'."\n";

       $item = 0;
       $items = sizeof($categories);
       $nbrows = ceil($items / $nbcols);

       $catlevel = 0;

       // *** Loading Bots if requested
       if ($params->botsoncatlistdesc ) {  // Need to process Bots ?
          //$_MAMBOTS->loadBotGroup( 'content' );  // Load published Bots from "Content" folder
          JPluginHelper::importPlugin( 'content' );  // Load published Bots from "Content" folder
       }

       for ($line=0; $line < $nbrows; $line++) {
           echo "      <tr>\n";
           for ($col=0; $col < $nbcols; $col++) {
               echo '        <td width="' .floor(100/$nbcols). '%" valign="top">';    //   nowrap="nowrap"
               $item = ($col*$nbrows) + $line;
               if ( $item < $items ) {

                  $cat = $categories[$item];

                  if ($cat->catid > 0) {
                     $catlevel = 1;
                     $p = 0;
                     $p = strpos($cat->name,"/",$p);
                     while ($p > 0) {
                        $p = strpos($cat->name,"/", $p+1);
                        $catlevel++;
                     }
                  }

                  echo '<div>';

                  if ($catid == $cat->catid) { echo '<span'.mosBookmarksTools::cssClass($params->csscategoriessel).'>['; }

                    if ( $cat->numlinks != 0 || $cat->numchild != 0 ) {
                       echo '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=".$params->mode."&catid=".$cat->catid."&navstart=".$params->navstart."&search=".$params->search). '"'.mosBookmarksTools::cssClass($params->csscategories).' title="' .htmlspecialchars($cat->name, ENT_NOQUOTES);
                       if ($params->catshowcount) {
                          echo '&nbsp;(';
                          echo ($params->catshowcount == 1 || $params->catshowcount == 2) ? $cat->numlinks." "._BMU_BOOKMARKS : "";
                          echo ($params->catshowcount == 1) ? ' + ' : "";
                          echo ($params->catshowcount == 1 || $params->catshowcount == 3) ? $cat->numchild." "._BMU_SUBCATEGORIES : "";
                          echo ')';
                       }
                       echo '">';
                    }

                    if ( ( ($catlevel <= 2 && $params->catlistmode==1) || ($params->catlistmode==2) ) && $cat->icon) {
                       $iconurl = JUri::base(true). '/images/stories/' .$cat->icon;
                       echo '<img src="' .$iconurl. '" border="0" />&nbsp;';
                    } else {
                       for ($l=0; $l < $catlevel-1; $l++) {
                          if ($params->catlistmode > -1) {
                             echo mosBookmarksTools::imageArrow();  // Using default template bullet (list), instead of fixed image...
                          } else {
                             echo "#&nbsp;";   // Keep Indentation...
                          }
                       }
                    }

                    echo htmlspecialchars($cat->title, ENT_NOQUOTES);

                    if ( $cat->numlinks != 0 || $cat->numchild != 0 ) {
                         echo '</a>';
                    }

                  if ($params->catshowcount) {
                     echo '&nbsp;<span class="small">(';
                     echo ($params->catshowcount == 1 || $params->catshowcount == 2) ? $cat->numlinks : "";
                     echo ($params->catshowcount == 1) ? '+' : "";
                     echo ($params->catshowcount == 1 || $params->catshowcount == 3) ? $cat->numchild : "";
                     echo ')</span>';
                  }

                  if ($catid == $cat->catid) { echo "]</span>"; }

                  echo '</div>';

                  // *** Display Category Description
                  if ($params->showcatlistdesc && $cat->description) {
                     if ($params->botsoncatlistdesc ) {  // Need to process Bots ?

                        $row->text = $cat->description;    // MosBot only uses field "text" => Need to copy "detail" content ...
                        $row->images = "";                 // MosBot Need to simulate "images" field (must be present, but keep it empty)
                        $row->sectionid = "";              // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
                        $page = 0;                         // MosBot pagination system
                        $prms = "";
                        $bmparams =& new JParameter( $prms );   // Use "$botparms" to avoid overwritting "$params" (from Module)

                        echo '<!-- Bots -->'."\n";
                        // Process the MosBots
                        //$results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
                        $results =  $mainframe->triggerEvent( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );

                        // Update field with processed text
                        $cat->description = $row->text;
                     }
                     echo $cat->description;
                  }
               }
               echo "</td>\n";
           }
           echo "      </tr>\n";
       }

       echo "    </table>\n";
       echo "  </td></tr>\n";

    }
  }



  function alphaV ($val) {
    $alphaIndex = mosBookmarks::alphaIndex();
    // $val => *=-1 ]=0 / A=1 .. Z=26 / [=27
    $c = 0;
    if ($val > count($alphaIndex)-1 ) { $val = count($alphaIndex)-1; }       // protection for too high index
    switch ($val) {
      case -1 :     // All
          $c = "*"; break;
      default :
          $c =  ($alphaIndex[$val]);
    }
    return $c;
  }


  function alphaTest ($val) {
    $alphaIndex = mosBookmarks::alphaIndex();
    // $val => *=-1 ]=A / A=B .. Z=] / [=chr(255)
    $c = 0;
    if ($val >= count($alphaIndex) ) { $val = count($alphaIndex)-1; }       // protection for too high index
    switch ($val) {
      case count($alphaIndex)-1 :    // More than Z => Special chars
          $c = chr(255);  break;
      default :       // Chars
          $c =  ($alphaIndex[$val+1]);
    }
    return $c;
  }


  function ShowAlphaIndex ($option, $Itemid, $catid, &$params) {
    $alphaIndex = mosBookmarks::alphaIndex();
    $mode = $params->mode;
    echo '<tr align="center"><td'.mosBookmarksTools::cssClass($params->cssalphaindex).'>'."\n";
    $params->search = rawurldecode($params->search);   // Convert special chars to normal chars... => fix issue with ]=%5d and [=%5b
    if ($params->showsearchbox) {
//       echo '<form action="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&navstart=0"). '" method="post">'."\n";  // <== SEF conversion on Form submission makes some conflicts...
       echo '<form action="'. JRoute::_("index.php?option=".$option."&Itemid=".$Itemid."&mode=".$mode."&catid=".$catid."&navstart=0") .'" method="post">'."\n";
       echo '<input class="inputbox" type="text" name="search" value="'.$params->search.'" size="'.$params->searchboxsize.'" />&nbsp;'."\n";
    }
    if ($params->showalphaindex) {
      if ($params->search == "*") { echo '<span'.mosBookmarksTools::cssClass($params->cssalphaindexsel).'>['; }
      echo '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&navstart=0&search=*"). '" ><b>' ._BMU_ALL_BOOKMARKS. '</b></a>';
      if ($params->search == "*") { echo ']</span>'; }
      for ($ii=0; $ii <= count($alphaIndex)-1; $ii++) {
          $s = HTML_bookmarks::alphaV($ii);
          if ($params->alphaindexsep1 == "S") {
             echo "&nbsp;";
          } elseif ($params->alphaindexsep1 != "N") {
             echo $params->alphaindexsep1;
          }
          if (strtoupper($params->search) == $s) { echo '<span'.mosBookmarksTools::cssClass($params->cssalphaindexsel).'>['; }
             echo '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&navstart=0&search=".strtolower($s)). '"><b>'.$s.'</b></a>';
          if (strtoupper($params->search) == $s) { echo ']</span>'; }
      }
      echo "\n";
    }
    if ($params->showsearchbox) {
       echo '</form>'."\n";
    }
    echo '</td></tr>'."\n";

  }


  function BackToIndexAlpha ($option, $Itemid, $catid, &$params, $alpha, &$blocks, $last=false) {

    $mode = $params->mode;
    echo '<tr align="left"><td>'."\n";

    echo '   <table border="0" cellspacing="0" cellpadding="0" width="100%">'."\n";
    echo '    <tr>'."\n";

    if (!$last) {
       echo '     <td '.mosBookmarksTools::cssClass($params->csscategoryheader).' width="100%" valign="top">';
       echo '<a name="BM'.$alpha.'"></a>';    // Alpha Anchor
       echo $alpha;                           // Alpha Heading
       echo '&nbsp;</td>'."\n";
    } else {
       echo '     <td width="100%" valign="top">';
       echo '&nbsp;</td>'."\n";
    }

    echo '     <td class="button" nowrap="nowrap">';       // index
    if ( count($blocks) > 1 ) {
       foreach ($blocks as $block) {
          echo '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&navstart=".$params->navstart."&search=".$params->search). '#BM'.$block->car.'">' .$block->car. '</a>';
          if ($params->alphaindexsep2 == "S") {
             echo " ";
          } elseif ($params->alphaindexsep2 != "N") {
             echo $params->alphaindexsep2;
          }
       }
    }

    if ($params->showtopindex) {
       if ( $params->alphaindexsep2 == "N" ) { echo "&nbsp;"; }
       if ($params->showalphaindex) {
          echo '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&navstart=".$params->navstart."&search=".$params->search). '#BMIndex">'._BMU_TO_INDEX.'</a>';                // Alpha Index
       } else {
          echo '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&navstart=".$params->navstart."&search=".$params->search). '#top">'._BMU_TO_TOP.'</a>';                    // Back to top of page...
       }
    }

    echo '</td>'."\n";                     // End index

    echo '    </tr>'."\n";
    echo '   </table>'."\n";

    echo '</td></tr>'."\n";
  }


function DisplayCatImageDesc ($option, $Itemid, $bmcat, &$params, &$blocks) {
  global $mainframe;
    $mode = $params->mode;

    // *** Show Category Image & Description
    echo '<!-- Cat Description & Image -->'."\n";
    if ( ($bmcat->image) != '' || trim(strip_tags($bmcat->description)) != '' ) {
       echo '<tr class="contentdescription" align="left" valign="top"><td>'."\n";
       if ( $bmcat->image ) {
          $img='stories/'.$bmcat->image;
          $align=$bmcat->image_position;
          echo '<img src="' .JURI::root(). 'images/' .$img. '" align="' .$align. '" hspace="6" title="' ._BMU_BOOKMARKS. ' : ' .htmlspecialchars($bmcat->cat, ENT_NOQUOTES). '" alt="' ._BMU_BOOKMARKS. ' : ' .htmlspecialchars($bmcat->cat, ENT_NOQUOTES). '" />';

//     } else {   // Default image for categories, if none set...
//        $img=JURI::root().'components/com_bookmarks/images/bookmarks.png';       //  => We do prefer hidden if not set, as not set is not set, not with a default... :-)
//        $align='right';
//        echo '<img src="' .JURI::root(). 'images/' .$img. '" align="' .$align. '" hspace="6" title="' ._BMU_BOOKMARKS. ' : ' .htmlspecialchars($bmcat->cat, ENT_NOQUOTES). '" alt="' ._BMU_BOOKMARKS. ' : ' .htmlspecialchars($bmcat->cat, ENT_NOQUOTES). '" />';

       }
       if ( $bmcat->description != '' ) {
          if ($params->botsoncatdesc ) {  // Need to process Bots ?

             $row->text = $bmcat->description;  // MosBot only uses field "text" => Need to copy "detail" content ...
             $row->images = "";                 // MosBot Need to simulate "images" field (must be present, but keep it empty)
             $row->sectionid = "";              // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
             $page = 0;                         // MosBot pagination system
             $prms = "";
             $bmparams =& new JParameter( $prms );   // Use "$botparms" to avoid overwritting "$params" (from Module)

             echo '<!-- Bots -->'."\n";
             // Process the MosBots
             //$_MAMBOTS->loadBotGroup( 'content' );  // Load published Bots from "Content" folder
             JPluginHelper::importPlugin( 'content' );  // Load published Bots from "Content" folder
             //$results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
             $results =  $mainframe->triggerEvent( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );

             // Update field with processed text
             $bmcat->description = $row->text;
          }
          echo $bmcat->description;

//     } else {        // Default Description
//        echo _BMU_BOOKMARKS_DESC;                                      //  => We do prefer hidden if not set, as not set is not set, not with a default... :-)

       }
       echo "\n".'</td></tr>'."\n";
    }
}

  function BackToIndexCat ($option, $Itemid, $bmcat, &$params, &$blocks, $last=false) {

    $mode = $params->mode;

    if ( ($mode == 0 && $params->showcattitle) || $mode > 0) {

       echo '<tr><td>'."\n";

       echo ' <table border="0" cellspacing="0" cellpadding="0" width="100%">'."\n";
       echo ' <tr>'."\n";

       if (!$last) {
          if ($params->showcaticon && $bmcat->icon) {
             echo '  <td nowrap="nowrap">';
             $iconurl = JUri::base(true). '/images/stories/' .$bmcat->icon;
             echo '<img src="' .$iconurl. '" border="0" hspace="2" title="'.$bmcat->cat.'" alt="'.$bmcat->icon.'" />';
             echo '</td>'."\n";
          }
       }

       echo '  <td valign="bottom" width="100%">'."\n";                        // End Index

       echo '   <table border="0" cellspacing="0" cellpadding="0" width="100%">'."\n";
       echo '    <tr>'."\n";

       if (!$last) {
          echo '     <td '.mosBookmarksTools::cssClass($params->csscategoryheader).' width="100%" valign="top">';
          echo '<a name="BM'.$bmcat->id.'"></a>';
          $pos = strpos($bmcat->cat," / ");
          if ($pos != false) {
             $cat2 = substr($bmcat->cat,$pos+3);
          } else {
             $cat2 = $bmcat->cat;
          }
          echo $cat2;         // Cats Heading - Remove "RootCat" from Cat name
          echo '&nbsp;</td>'."\n";
       } else {
          echo '     <td width="100%" valign="top">';
          echo '&nbsp;</td>'."\n";
       }

       if ($params->showtopindex) {
          if ($mode != 0 || ($mode == 0 && $last) ) {  // Do not display Index/Top for OneCat mode or if it's the "last line" index
             echo '     <td class="button">';   // start index
             if ($params->showalphaindex) {
                echo '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=".$bmcat->id."&navstart=".$params->navstart."&search=".$params->search). '#BMIndex">'._BMU_TO_INDEX.'</a>';              // Cats Index
             } else {
                echo '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=".$bmcat->id."&navstart=".$params->navstart."&search=".$params->search). '#top">'._BMU_TO_TOP.'</a>';                    // Back to top of page...
             }
             echo '</td>'."\n";                 // End Index
          }
       }
       echo '    </tr>';
       echo '   </table>'."\n";

       echo '  </td>';
       echo ' </tr>'."\n";
       echo ' </table>'."\n";

       echo '</td></tr>'."\n";

       if (!$last) {
          if ($params->showcatdesc == 1 || ( $params->showcatdesc == 2 && $mode == 0 ) || ( $params->showcatdesc == 3 && $mode == 2 ) ) {
             if ($params->showcatdescpos == 0) {
               HTML_bookmarks::DisplayCatImageDesc ($option, $Itemid, $bmcat, $params, $blocks);
             }
          }
       }
    }

  }


  function ShowDisplaymode($option, $Itemid, $catid, &$params) {
	 $my =& JFactory::getUser();

     echo '  <tr><td'.mosBookmarksTools::cssClass($params->cssdisplaymode).'>';
     if ( _BMU_DISPLAY_MODE) { echo _BMU_DISPLAY_MODE . "&nbsp;"; };
     if ($params->mode == 0) { echo '<span'.mosBookmarksTools::cssClass($params->cssdisplaymodesel).'>['; }
        echo '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=0&catid=$catid&navstart=0&search=".$params->search). '">' ._BMU_DISPLAY_ONECAT. '</a>';
     if ($params->mode == 0) { echo ']</span>'; }
     echo '&nbsp;|&nbsp;';
     if ($params->mode == 1) { echo '<span'.mosBookmarksTools::cssClass($params->cssdisplaymodesel).'>['; }
     echo '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=1&catid=$catid&navstart=0&search=".$params->search). '">' ._BMU_DISPLAY_BYALPHA. '</a>';
     if ($params->mode == 1) { echo ']</span>'; }
     echo '&nbsp;|&nbsp;';
     if ($params->mode == 2) { echo '<span'.mosBookmarksTools::cssClass($params->cssdisplaymodesel).'>['; }
     echo '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=2&catid=$catid&navstart=0&search=".$params->search). '">' ._BMU_DISPLAY_BYCATS. '</a>';
     if ($params->mode == 2) { echo ']</span>'; }
     echo '&nbsp;|&nbsp;';
     if ($params->mode == 3) { echo '<span'.mosBookmarksTools::cssClass($params->cssdisplaymodesel).'>['; }
     echo '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=3&catid=$catid&navstart=0&search=".$params->search). '">' ._BMU_DISPLAY_ALLALPHA. '</a>';
     if ($params->mode == 3) { echo ']</span>'; }
     echo '</td></tr>'."\n";

  }


  function ShowNavigator($option, $Itemid, $catid, &$params) {
	 $my =& JFactory::getUser();


     if ($params->navtotal > 0) {
        $params->navpos = $params->navstart*$params->navperpage;
        $params->navposend = ($params->navtotal > (($params->navstart+1)*$params->navperpage)-1 ) ? ($params->navstart+1)*$params->navperpage-1 : $params->navtotal-1;
        $params->navprev = ($params->navstart > 0) ? $params->navstart-1 : 0;
        $params->navnext = ($params->navtotal > $params->navposend) ? $params->navstart+1 : $params->navstart+1 ;
        $params->navhide = 5;

        echo '  <tr><td align="center">';
//        if ( $params->navperpage > 0 ) {                        // To display Navigator if there is some Bookmarks to display, even ther is only one item...
        if ( $params->navperpage > 0 && $params->navtotal > $params->navperpage) {    // To display Navigator if there is some Bookmarks to display, even ther is only one item...

           // ** START
           echo '<span class="pagenav">';
           if ($params->navstart > 0) {
              echo '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=".$params->mode."&catid=$catid&navstart=0&search=".$params->search). '">';
           }
           echo '&lt;&lt;&nbsp;' . _PN_START;
           if ($params->navstart > 0) {
              echo '</a>';
           }
           echo '</span>';

           echo ' ';

           // ** PREVIOUS
           echo '<span class="pagenav">';
           if ($params->navstart > 0) {
             echo '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=".$params->mode."&catid=$catid&navstart=".$params->navprev."&search=".$params->search). '">';
           }
           echo '&lt;&nbsp;' . _PN_PREVIOUS;
           if ($params->navstart > 0) {
              echo '</a>';
           }
           echo '</span>';

           echo ' ';
           // ** PAGES
           for ($i=0; $i <= $params->navend; $i++) {

             if ( ($i == $params->navstart-$params->navhide-1) || ($i == $params->navstart+$params->navhide+1) ) {
                echo '<span class="pagenav">...</span>';
                echo ' ';
             } else if ( ($i > $params->navstart-$params->navhide-1) && ($i < $params->navstart+$params->navhide+1) ) {
                echo '<span class="pagenav">';
                if ($params->navstart == $i) {
                   echo '<b>[';
                }
                echo '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=".$params->mode."&catid=$catid&navstart=$i&search=".$params->search). '">';
                echo $i+1;
                echo '</a>';
                if ($params->navstart == $i) {
                   echo ']</b>';
                }
                echo '</span>';
                echo ' ';
             }
           }

           // ** NEXT
           echo '<span class="pagenav">';
           if ($params->navnext <= $params->navend) {
             echo '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=".$params->mode."&catid=$catid&navstart=".$params->navnext."&search=".$params->search). '">';
           }
           echo _PN_NEXT . '&nbsp;&gt;';
           if ($params->navnext <= $params->navend) {
              echo '</a>';
           }
           echo '</span>';

           echo ' ';

           // ** END
           echo '<span class="pagenav">';
           if ($params->navstart < $params->navend) {
              echo '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=".$params->mode."&catid=$catid&navstart=".$params->navend."&search=".$params->search). '">';
           }
           echo _PN_END . '&nbsp;&gt;&gt;';
           if ($params->navstart < $params->navend) {
              echo '</a>';
           }
           echo '</span>';

           // *** "Split Results ?" => [True] : Results on a second line / [False] : Result on same line as navigator !
           echo (true) ? "<br />\n" : "&nbsp;/&nbsp;";
        }

        if ($params->shownavresults) {
           // ** Display Navigator Results
           echo _PN_RESULTS . ": ";
           echo ($params->navtotal > 0) ? ($params->navpos+1) : 0;
           echo " - ";
           if ($params->navperpage > 0) {
              echo ($params->navpos + $params->navperpage <= $params->navtotal) ? $params->navpos+$params->navperpage : $params->navtotal;
           } else {
              echo $params->navtotal;
           }
           echo " ". _PN_OF . " " . $params->navtotal."\n";
        }
        echo '</td></tr>'."\n";

     }
  }


  function ShowSubmit($option, $Itemid, $catid, &$params) {
	 $my =& JFactory::getUser();

     if ( ( $params->cansubmit && $my->gid >= $params->submitlevel ) || $params->forcesubmitlink ) {
        echo '  <tr><td>';
        echo '<img src="' .JURI::root(). 'images/M_images/new.png" width="13" height="14" align="middle" border="0" alt="' ._BMU_SUBMIT_NEW. '" hspace="2" />';
        echo '<a href="' .JRoute::_("index.php?option=$option&task=new&Itemid=$Itemid&mode=".$params->mode."&catid=$catid&navstart=0&search=".$params->search). '">';
        echo _BMU_SUBMIT_NEW;
        echo '</a>';
        echo '</td></tr>'."\n";
     }
  }


  function BMSortArrow ($option, $Itemid, $catid, $orderby, $orderbyupdown, $curorderby, &$params) {
    if ($params->showheadersort) {
       $img = "components/com_bookmarks/images/";
       $img .= ($orderbyupdown == 'asc') ? "up" : "down";
       $selected = (strtolower($orderby) == $curorderby);
       $img .= ($selected) ? "_selected.png" : ".png";
       if ($selected) {
          $orderbyupdown = ($orderbyupdown == "asc") ? "desc" : "asc";     // Invert sort for link...
       }
       echo '<a href="' .JRoute::_("index.php?option=$option&task=order&Itemid=$Itemid&mode=".$params->mode."&catid=$catid&orderbycol=$orderby&orderbyupdown=$orderbyupdown&search=".$params->search). '"><img src="' .$img. '" border="0" hspace="2" alt="" /></a>';
    }
  }



  function displayHeader (&$option, &$Itemid, &$catid, &$nbcols, &$hidecols, &$nbcol, &$orderbycol, &$orderbyupdown, &$params, &$access) {
		  $my =& JFactory::getUser();

          if ($nbcols==0) { $nbcols = 1; }

          echo '<!-- Bookmarks Header -->'."\n";
          if ($params->showheader) {
             echo '      <tr valign="middle">'."\n";
          }

          for ($col=0; $col <= (($nbcols-1) - $hidecols); $col++) {  // Multi-columns

            $nbcol = 0;

            if ($col > 0) {
               if ($params->showheader) {
                  echo '        <td width="17"'.mosBookmarksTools::cssClass($params->csstableheader).' nowrap="nowrap" style="padding-left: 6pt;padding-right: 6pt;background-image: url(' .JURI::root(). 'components/com_bookmarks/images/separator.png);">';
                  echo '</td>'."\n";
               }
            }

            // *** Edit Bookmarks icon
            if ( ( $access->canEdit ) || ( $access->canEditOwn ) || ( $params->regcaneditown && $my->id ) ) {
               if ($params->showheader) {
                  echo '        <td width="17" align="center"'.mosBookmarksTools::cssClass($params->csstableheader).'>&nbsp;</td>'."\n";
               }
            }


            foreach ($params->columns as $column) {

              // *** Column : Icons
              if ($column->name == "icon" && $column->visible ) {
                 if ($params->showheader) {
                    echo '        <td width="20" align="center"'.mosBookmarksTools::cssClass($params->csstableheader).'>&nbsp;</td>'."\n";
                 }
                 $nbcol++;
              }

              // *** Column : Bookmarks
              if ($column->name == "bookmark" && $column->visible ) {
                 if ($params->showheader) {
                    echo '        <td width="';
                    echo ( mosBookmarksTools::isColVisible('description', $params->columns) && !$params->showdescsplit ) ? floor(45/($nbcols-$hidecols))."%" : floor(100/($nbcols-$hidecols))."%";
                    echo '" align="left" nowrap="nowrap"'.mosBookmarksTools::cssClass($params->csstableheader).'>';
                    echo _BMU_BOOKMARKS;
                    if ($params->bmsort == 1) {
                       HTML_bookmarks::BMSortArrow($option, $Itemid, $catid, 'ordering', $orderbyupdown, $orderbycol, $params );
                    } elseif ($params->bmsort == 2) {
                       HTML_bookmarks::BMSortArrow($option, $Itemid, $catid, 'created', $orderbyupdown, $orderbycol, $params );
                    } else {
                       HTML_bookmarks::BMSortArrow($option, $Itemid, $catid, 'title', $orderbyupdown, $orderbycol, $params );
                    }
                    echo '</td>'."\n";
                 }
                 $nbcol++;
              }

              // *** Column : Description
              if ( $column->name == "description" && $column->visible && ( !$params->showdescsplit || ( !mosBookmarksTools::isColVisible ('bookmark', $params->columns) && $params->showdescsplit==1 ) ) ) {
                 if ($params->showheader) {
                    echo '        <td';
                    if ($nbcols-$hidecols > 1) {
                       echo ' width="';
                       echo ( mosBookmarksTools::isColVisible ('bookmark', $params->columns) ) ? floor(55/($nbcols-$hidecols))."%" : floor(100/($nbcols-$hidecols))."%";
                       echo '"';
                    }
                    echo ' align="left" nowrap="nowrap"'.mosBookmarksTools::cssClass($params->csstableheader).'>';
                    echo _BMU_DESCRIPTION;
                    HTML_bookmarks::BMSortArrow($option, $Itemid, $catid, 'description', $orderbyupdown, $orderbycol, $params );
                    echo '</td>'."\n";
                 }
                 $nbcol++;
              }

                 // *** Column : Image  (sorted by Title)
              if ($column->name == "image" && $column->visible ) {
                 if ($params->showheader) {
                    echo '        <td width="';
                    echo ( !mosBookmarksTools::isColVisible ('bookmark', $params->columns) && !mosBookmarksTools::isColVisible ('description', $params->columns) ) ? floor(100/($nbcols-$hidecols)).'%' : '60';
                    echo '" align="left" nowrap="nowrap"'.mosBookmarksTools::cssClass($params->csstableheader).'>';
                    echo _BMU_IMAGE;
                    if ($params->bmsort == 1) {
                       HTML_bookmarks::BMSortArrow($option, $Itemid, $catid, 'ordering', $orderbyupdown, $orderbycol, $params );
                    } elseif ($params->bmsort == 2) {
                       HTML_bookmarks::BMSortArrow($option, $Itemid, $catid, 'created', $orderbyupdown, $orderbycol, $params );
                    } else {
                       HTML_bookmarks::BMSortArrow($option, $Itemid, $catid, 'title', $orderbyupdown, $orderbycol, $params );
                    }
                    echo '</td>'."\n";
                 }
                 $nbcol++;
              }

              // *** Column : Rating
              if ($params->canvote && $column->name == "rating" && $column->visible ) {
                 if ($params->showheader) {
                    $disp = (($params->canvotedetail == 0 || $params->canvotedetail == 1) && $my->gid >= $params->votelevel) ? 1 : 0;
                    echo '        <td width="';
                    if ($disp) {
                       switch ($params->showratingsplit) {
                         case "1" :
                             echo '100';     // for stars above the vote button
                             break;
                         case "2" :
                             echo '60';      // for the all elements on the same line
                             break;
                         case "0" :
                         default :
                             echo '160';     // for elements on 3 lines
                       }
                    } else {                 // Not allowed to vote => Only Stars
                      echo '60';
                    }
                    echo '" align="center" nowrap="nowrap"'.mosBookmarksTools::cssClass($params->csstableheader).'>'."\n";
                    echo _BMU_RATING;
                    HTML_bookmarks::BMSortArrow($option, $Itemid, $catid, 'rating', $orderbyupdown, $orderbycol, $params );
                    echo '</td>'."\n";
                 }
                 $nbcol++;
              }

              // *** Column : Hits
              if ($column->name == "hits" && $column->visible ) {
                 if ($params->showheader) {
                    echo '        <td width="60" align="center" nowrap="nowrap"'.mosBookmarksTools::cssClass($params->csstableheader).'>';
                    echo _BMU_HITS;
                    HTML_bookmarks::BMSortArrow($option, $Itemid, $catid, 'hits', $orderbyupdown, $orderbycol, $params );
                    echo '</td>'."\n";
                 }
                 $nbcol++;
              }

              // *** Column : Date
              if ($column->name == "created" && $column->visible ) {
                 if ($params->showheader) {
                    echo '        <td width="110" align="left" nowrap="nowrap"'.mosBookmarksTools::cssClass($params->csstableheader).'>';
                    echo _BMU_DATE;
                    HTML_bookmarks::BMSortArrow($option, $Itemid, $catid, 'created', $orderbyupdown, $orderbycol, $params );
                    echo '</td>'."\n";
                 }
                 $nbcol++;
              }

              // *** Column : Publisher (created_by)
              if ($column->name == "created_by" && $column->visible ) {
                 if ($params->showheader) {
                    echo '        <td width="80" align="left" nowrap="nowrap"'.mosBookmarksTools::cssClass($params->csstableheader).'>';
                    echo _BMU_PUBLISHER;
                    HTML_bookmarks::BMSortArrow($option, $Itemid, $catid, 'created_by', $orderbyupdown, $orderbycol, $params );
                    echo '</td>'."\n";
                 }
                 $nbcol++;
              }

              // *** Column : Custom Fields
              if ($column->custom == 1 && $column->visible && ( $column->f_type != 8 || ($column->f_type == 8 && $params->canvote) ) ) {
                 if ($params->showheader) {
                    $name = $column->name;
                    if ($column->f_type == 8) {
                       echo '        <td width="';
                       echo ( $params->showratingsplit ) ? '60' : '120';
                       echo '" align="center" class="sectiontableheader" nowrap="nowrap">';
                    } else {
                       echo '        <td width="60" align="left" nowrap="nowrap"'.mosBookmarksTools::cssClass($params->csstableheader).'>';
                    }
                    echo $column->title;
                    HTML_bookmarks::BMSortArrow($option, $Itemid, $catid, $name, $orderbyupdown, $orderbycol, $params );
                    echo '</td>'."\n";
                 }
                 $nbcol++;
              }


            } // Show column header loop

            if ( !mosBookmarksTools::isColVisible('bookmark', $params->columns)
                 && !mosBookmarksTools::isColVisible('description', $params->columns)
                 && !mosBookmarksTools::isColVisible('image', $params->columns)
               ) {
               if ($params->showheader) {
                  echo '        <td width="'.floor(100/($nbcols-$hidecols)).'%" align="left" nowrap="nowrap"'.mosBookmarksTools::cssClass($params->csstableheader).'>&nbsp;</td>'."\n";
               }
               $nbcol++;
            }

          } // multi columns

          if ($params->showheader) {
             echo '      </tr>'."\n";
          }


}


// ***********************************
// ***                              **
// ***  Display the Bookmarks List  **
// ***                              **
// ***********************************


  function displaylist( $option, &$categories, &$rows, $catid, &$currentcat, $pathcat, &$lists, $access, $msg, $orderbycol, $orderbyupdown, &$params ) {
    global $Itemid, $mainframe;
    global $snaps;
    $my =& JFactory::getUser();
    $alphaIndex = mosBookmarks::alphaIndex();

    echo "\n".'<!-- ### START Component : Bookmarks (c) www.TEGDesign.ch '.mosBookmarks::getVersion().' ### -->'."\n\n";

    $params->_Itemid = $Itemid;
    $params->_option = $option;
    $params->_catid = $catid;

    JHTML::_('behavior.tooltip');          // Import Tooltip Library

    /* Tooltips - Force width to max 500 pixels to display all stuff */
?>
    <style type="text/css">
    .tool-tip {
/*
		background: #ffc;*/

	max-width: 500px;
    }
    .tool-title {
	border-bottom: 1px solid #D4D5AA;
    }
    </style>
<?php

//    echo "DEBUG: 2 catid : ".$catid."<br />\n";

    echo '<a name="BMIndex"></a>'."\n"; // Anchor to come back to index.

/*
foreach ($rows as $r) {
  echo '<span style="color: Green; font-weight: bold;">DEBUG</span> ';
  foreach ($r as $k=>$v) {
    echo "| <b>$k</b>: $v ";
  }
  echo "<br /><hr />\n";
}
*/

    // MosBot : Convert "$params" to "JParameter" format
    $prms = "";
    $bmparams =& new JParameter( $prms );   // Use "$botparms" to avoid overwritting "$params" (from Module)
    foreach ($params as $k=>$v) {
       $bmparams->def($k,$v);
    }

    // *** Component Table (master)
    echo '<table class="contentpane" border="0" cellpadding="' .$params->paddingheader. '" cellspacing="0" width="100%">'."\n";

    // *** System message (After new submission)
    echo '<!-- Message -->'."\n";
    switch ($msg) {
      case "msg1" :
          $message = _BMU_ITEM_ADDED_MUST_APPROVED_BY_ADMIN;
          break;
      case "msg2" :
          $message = _BMU_MAIL_SENT;
          break;
      default :
          $message = '';
    }

    if ( $message ) {
       echo '  <tr align="center"><td><b>' .$message. '</b></td></tr>'."\n";
       echo '  <tr><td>&nbsp;</td></tr>'."\n";
    }

    echo '<!-- Page Title -->'."\n";
    if ($params->showpagetitle) {
       echo (_BMU_BOOKMARK_LIST) ? '<tr><td><div class="componentheading">'._BMU_BOOKMARK_LIST.'</div></td></tr>'."\n" : "";
    }

    echo '<!-- Component Header -->'."\n";
    if ($params->comheaderlist) {
       if ($params->comheaderlist && $params->botsonheaderlist) {
          // MosBot : The {MosImage} is no supported as the Images field is not present !!! => Need to use fixed path for images...
          $row->text = $params->comheaderlist;   // MosBot only uses field "text" => Need to copy "detail" content ...
          $row->images = "";                     // MosBot Need to simulate "images" field (must be present, but keep empty)
          $row->sectionid = "";                  // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
          $page = 0;                             // MosBot pagination system

          // Process the MosBots
          JPluginHelper::importPlugin( 'content' );  // Load published Bots from "Content" folder
          $results =  $mainframe->triggerEvent( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
          $params->comheaderlist = $row->text;
       }
       echo '<tr><td><div class="contentpane">';
       echo $params->comheaderlist;
       echo '</div></td></tr>'."\n";
    }

    // *** Show Display Mode Navigation
    echo '<!-- Navigation : Display Mode -->'."\n";
    if ($params->showdisplaymode) {
       HTML_bookmarks::ShowDisplaymode($option, $Itemid, $catid, $params);
    }

    // *** Show Display Search Index
    echo '<!-- Search Index -->'."\n";
    if ( $params->showalphaindex || $params->showsearchbox) {
       HTML_bookmarks::ShowAlphaIndex($option, $Itemid, $catid, $params);
    }

    // *** Show Submission link on TOP
    echo '<!-- Submit New (Top) -->'."\n";
    if ($params->submitpos == '1') {
       HTML_bookmarks::ShowSubmit($option, $Itemid, $catid, $params);
    }

    // *** Show Pathway
    echo '<!-- Pathway -->'."\n";
    if ($params->mode == 0 && ($params->showpathway == 1 || $params->showpathway == 2) ) {
       echo '  <tr><td>' .$pathcat. '</td></tr>'."\n";
    }

    // *** Show Categories on TOP
    echo '<!-- Categories (TOP) -->'."\n";
    if ($params->catpos == '1' && $params->mode == 0 && $params->showcats) {
       switch ($params->catdisplayorder) {
         case "1" :
             HTML_bookmarks::ShowCatsHoriz($option, $catid, $categories, $Itemid, $params);
             break;
         case "2" :
             HTML_bookmarks::ShowCatsTree($option, $catid, $categories, $Itemid, $params);
             break;
         case "0" :
         default :
             HTML_bookmarks::ShowCatsVert($option, $catid, $categories, $Itemid, $params);
       }
    }


    // *** Show Navigator on TOP
    echo '<!-- Navigator (Top) -->'."\n";
    if ($params->navigatorpos == '1' || $params->navigatorpos == '3') {
          HTML_bookmarks::ShowNavigator($option, $Itemid, $catid, $params);
    }


    $blockfirst = 0;
    $blocklast = 0;

    $blocks = array();
    $block = 0;

    if ($params->mode == 0) {    // Display : One Cat
       $blocks[$block]->block = -1;
       $blocks[$block]->car = HTML_bookmarks::alphaV(-1);
       $blocks[$block]->first = $blockfirst;
       $blocks[$block]->last = count($rows);
       $blocks[$block]->cat = $currentcat->name;              // First Category : Name
       $blocks[$block]->catdesc = $currentcat->description;   // First Category : Description
       $blocks[$block]->car = "";
    }

    if ($params->mode == 3) {    // Display : Alpha not grouped
       $blocks[$block]->block = -1;
       $blocks[$block]->car = HTML_bookmarks::alphaV(-1);
       $blocks[$block]->first = $blockfirst;
       $blocks[$block]->last = count($rows);
       $blocks[$block]->car = "";
    }

    if ($params->mode == 1 && count($rows) > 0) {    // Display : By Alpha
       $check = 0; // char to check...
       while ( $blocklast < count($rows) ) {  // scan All records
          if ( strtoupper(substr($rows[$blocklast]->title,0,1)) < HTML_bookmarks::alphaTest($check) ) {      // search last item of the block ( less than next block )
             $blocklast++;   // Item in block
          } else {
             if ($blocklast == $blockfirst) {   // There are item(s) in this block => display...
             } else {
                $blocks[$block]->block = $block;
                $blocks[$block]->first = $blockfirst;
                $blocks[$block]->last = $blocklast;
                $blocks[$block]->car = HTML_bookmarks::alphaV($check);
                $blocks[$block]->cat = "";
                $block++;                   // Next Block
                $blockfirst = $blocklast;   // Begin of next group
             }
             $check++;       // check next char block
          }
       }
       $blocks[$block]->block = $block;      // Last Block
       $blocks[$block]->first = $blockfirst;
       $blocks[$block]->last = count($rows);
       $blocks[$block]->car = HTML_bookmarks::alphaV($check);
       $blocks[$block]->cat = "";
    }

    if ($params->mode == 2 && count($rows) > 0) {    // Display : By Cats
       $lastcat = strtolower($rows[$blocklast]->category);   // First Category
       while ( $blocklast < count($rows) ) {  // scan All records
          if ( strtolower($rows[$blocklast]->category) == $lastcat ) {      // search last item of the block ( less than next block )
             $blocklast++;   // Item in block
          } else {
             $blocks[$block]->block = $block;
             $blocks[$block]->first = $blockfirst;
             $blocks[$block]->last = $blocklast;
             $blocks[$block]->cat = $rows[$blockfirst]->category;      // Categoy : Name
             $blocks[$block]->catdesc = $rows[$blockfirst]->catdesc;   // Category : Description
             $blocks[$block]->car = "";
             $block++;                   // Next Block
             $blockfirst = $blocklast;   // Begin of next group
             $lastcat = strtolower($rows[$blocklast]->category);       // check next cat block
          }
       }
       $blocks[$block]->block = $block;   // last block
       $blocks[$block]->first = $blockfirst;
       $blocks[$block]->last = count($rows);
       $blocks[$block]->cat = $rows[$blockfirst]->category;
       $blocks[$block]->car = "";
    }

    $nbcol = 0;

    $params->showsnapshoterpic = 0;  // Var Init to know if we have to display the Snapshoter's free service picture (adv)

//	echo "DEBUG: count rows:".count($rows)."<BR />";

    if ( count($rows) > 0 ) {  // Item(s) to display...
       for ($block=0; $block < count($blocks); $block++) {

          // *** Show Display BackTo Index (Group Header)
          if ($block > 0) {
             echo '<!-- Section Separator -->'."\n";
             echo '<tr><td>&nbsp;</td></tr>'."\n";  // Section separator
          }

/*
      echo "<tr><td>\n";
      echo "DEBUG: blockfirst: " .$blocks[$block]->first. "  blocklast: " .$blocks[$block]->last. "<br />\n";
      echo "DEBUG: [ Block: ".$blocks[$block]->block." / Car: " .$blocks[$block]->car. " / Cat: " .$blocks[$block]->car. " ]<br />\n";
      echo "</td></tr>\n";
*/

          // *** Show Display BackTo Index (Group Header)
          echo '<!-- Search BackTo Index -->'."\n";

          switch ($params->mode) {
            case 0 :   // One Cat
                $trow = $currentcat;       // User Current Cat as Cat Block
                $bmcat->id = $trow->id;
                $bmcat->cat = $trow->name;
                $bmcat->description = $trow->description;
                $bmcat->image = $trow->image;
                $bmcat->image_position = $trow->image_position;
                $bmcat->icon = $trow->icon;
                HTML_bookmarks::BackToIndexCat ($option, $Itemid, $bmcat, $params, $blocks );
                break;
            case 1 :   // Alpha Grouped
                HTML_bookmarks::BackToIndexAlpha ($option, $Itemid, $catid, $params, $blocks[$block]->car, $blocks );
                break;
            case 2 :   // Cat Grouped
                $trow = $rows[$blocks[$block]->first];       // Display item within block at correct grid position
                $bmcat->id = $trow->catid;
                $bmcat->cat = $trow->category;
                $bmcat->description = $trow->catdesc;
                $bmcat->image = $trow->image;
                $bmcat->image_position = $trow->image_position;
                $bmcat->icon = $trow->icon;
                HTML_bookmarks::BackToIndexCat ($option, $Itemid, $bmcat, $params, $blocks );
                break;
            case 3 :   // Cat Grouped
                $trow = $rows[$blocks[$block]->first];       // Display item within block at correct grid position
                $bmcat->id = $params->_catid;
                break;
            default :    // Other
          }

          $items = $blocks[$block]->last - $blocks[$block]->first;
          $nbcols = $params->nbcolumns;
          $nbrows = ceil($items / $nbcols);
          $max = $nbrows * $nbcols;
          $fullrows = ($nbcols-1)*($nbrows);
          $hidecols = 0;

          if ($params->mode == 0) {
             for ($c=0; $c < $nbcols; $c++) {   // Check is a some columns will stay blank on right
                $item = ($c * $nbrows);
                if ($item > $items-1) {
                   $hidecols++;
                }
             }
          }



          // *** Display Bookmarks Lists (if any found...)
          echo '<!-- Bookmarks -->'."\n";
//			echo "DEBUG: count:".count($items)."<BR />";
          if ( count( $items ) ) {

          echo '  <tr><td>'."\n";

          echo '<!-- Bookmarks Popup Script -->'."\n";
          mosBookmarksTools::bm_popup($params);   // Load Bookmarks popup script

          echo '<!-- Custom Field Popup Script -->'."\n";
          mosBookmarksTools::f_popup($params);   // Load Custom Fields popup script

          echo '    <table class="contentpane" width="100%" border="0" cellspacing="0" cellpadding="' .$params->paddingcolumns. '">'."\n";


          HTML_bookmarks::displayHeader ($option, $Itemid, $catid, $nbcols, $hidecols, $nbcol, $orderbycol, $orderbyupdown, $params, $access);


          // *** Display Bookmarks rows

          $tabclass = array("sectiontableentry1", "sectiontableentry2");
          $alternate = 0;

          $item = 0;

//          $params->showsnapshoterpic = 0;

          echo '<!-- Bookmarks Rows-->'."\n";

          if ($params->botsonbmdesc) {  // Process Bots only is allowed => may produce Performance issue is Bots are performed...
             //$_MAMBOTS->loadBotGroup( 'content' );  // Load published Bots from "Content" folder
             JPluginHelper::importPlugin( 'content' );  // Load published Bots from "Content" folder
          }

          for ($line=0; $line < $nbrows; $line++) {

              echo '      <tr class="' .$tabclass[$alternate]. '" valign="top">'."\n";

              for ($col=0; $col <= (($nbcols-1) - $hidecols); $col++) {

                  $item = ($col*$nbrows) + $line;                      // Compute grid position

                  if ( $item < $items ) {
                     $row = $rows[$blocks[$block]->first+$item];       // Display item within block at correct grid position

                     $valid_status = "";
                     $valid_img = "";

                     // *** Relace UID and UNAME Keywords with $my info
                     $row->url = str_replace("##MORE##",$params->keywordmore,$row->url);
                     $row->url = str_replace("##UID##",$my->id,$row->url);
                     $row->url = str_replace("##UNAME##",$my->username,$row->url);

                     // *** Process MosBots
                     if ( $params->botsonbmdesc && mosBookmarksTools::isColVisible ('description', $params->columns) && trim(strip_tags($row->description)) ) {
                        // *** MosBot : The {MosImage} is no supported as the Images field is not present !!! => Need to use fixed path for images...
                        $row->text = $row->description;  // MosBot only uses field "text" => Need to copy "detail" content ...
                        $row->images = "";               // MosBot Need to simulate "images" field (must be present, but keep empty)
                        $row->sectionid = "";            // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
                        $page = 0;                       // MosBot pagination system
                        // Process the MosBots
                        //$results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
                        $results =  $mainframe->triggerEvent( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
                        $row->description = $row->text;   // Return Converted text...
                     }

                     if ( $params->botsoncustommail) {  // process Bots on Custom field "Mail" for adress obfuscation...
                        foreach ($params->columns as $column) {
                           if ($column->custom == 1 && $column->visible && $column->f_type == 7 ) {  // Only on "Mail" field
                              $name = 'f_'.$column->name;
                              // Process the MosBots
                              $row->text = $row->$name;  // MosBot only uses field "text" => Need to copy "detail" content ...
                              //$results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
                              $results =  $mainframe->triggerEvent( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
                              $row->$name = $row->text;   // Return Converted text...
                           }
                        }
                     }

                     if ( $params->markvalidate ) {
                       mosBookmarksTools::ValidationInfo ($params, $row, $valid_status, $valid_img);
                     }

                     $picurl = mosBookmarksTools::prepareImageUrl($params, $row, true);


                     $overlibtxt = mosBookmarksTools::prepareOverlibBox($params, $row, $params->showurldetails, $picurl, $valid_status, $valid_img);

                     if ($row->redirect) {        // Show Detail page
                        $anchor = '<a href="'. JRoute::_("index.php?option=$option&Itemid=$Itemid&task=detail&catid=$catid&navstart=".$params->navstart."&mode=".$params->mode."&id=".$row->id."&search=".$params->search). '"'.mosBookmarksTools::cssClass($params->cssbookmarks).">";
                        $anchorend = '</a>';
                     } else {                     // Open URL
                        if ($row->url != "") {              // URL => Redirection...
                          if ($params->directurl) {                      // Use direct URL => No Hits Count !!!!
                             $anchor = '<a href="' .JRoute::_($row->url). '"';   // !?!? Do we need to convert the URL as it is "Direct URL" ? Yes, if the link is internal => processed by "mossef.php"...
                             if ($row->openwin == 0 || $row->openwin == 4) {   // Open url in the parent page
                                $anchor .= ' target="_parent"';
                             } else {                                          // Open url in a new page (also for Wrapper)
                                $anchor .= ' target="_blank"';
                             }
                          } else {
                             switch ($row->openwin) {
                               case "0" :
                                   $anchor = '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&task=view&id=".$row->id). '"';
                                   $anchor .= ' target="_parent"';
                                   break;
                               case "2" :    // Open url in Wrapper
                                   $anchor = '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&task=wrapper&id=".$row->id). '"';
                                   break;
                               case "3" :    // Open Direct url (Blank)
                                   $anchor = '<a href="' .JRoute::_($row->url). '"';
                                   $anchor .= ' target="_blank"';
                                   break;
                               case "4" :    // Open Direct url (Parent)
                                   $anchor = '<a href="' .JRoute::_($row->url). '"';
                                   $anchor .= ' target="_parent"';
                                   break;
                               case "1" :
                               default :
                                   $anchor = '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&task=view&id=".$row->id). '"';
                                   $anchor .= ' target="_blank"';
                             }
                          }

                          $anchor .= mosBookmarksTools::cssClass($params->cssbookmarks);
                          $anchor .= '>';
                          $anchorend = '</a>';
                        } else {                            // No URL => No redirection...
                          if ($params->emptyurlnolink) {
                            $anchor = '<span '.mosBookmarksTools::cssClass($params->cssbookmarks). '>';
                            $anchorend = '</span>';
                          } else {
                            $anchor = '<a href="javascript:void(0);"'.mosBookmarksTools::cssClass($params->cssbookmarks). '>';
                            $anchorend = '</a>';
                          }
                        }
                     }

                     // ** Column : Separator (if multiple columns)
                     if ($col > 0) {
                        echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosBookmarksTools::cssClass($params->cssbookmarksgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosBookmarksTools::cssClass($params->cssbookmarksbronze);
                          }
                          echo ' width="17" nowrap="nowrap" style="padding-left: 6pt;padding-right: 6pt;background-image: url(' .JURI::root(). 'components/com_bookmarks/images/separator.png);">';
                        echo '</td>'."\n";
                     }


                     // *** Column : Edit Bookmarks icon
                     if ( ( $access->canEdit ) || ( $access->canEditOwn ) || ( $params->regcaneditown && $my->id ) ) {
                        echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosBookmarksTools::cssClass($params->cssbookmarksgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosBookmarksTools::cssClass($params->cssbookmarksbronze);
                          }
                          echo ' width="17" align="center" valign="top" nowrap="nowrap">';
                        if (  $access->canEdit || ( $access->canEditOwn && $row->created_by == $my->id ) || ( $params->regcaneditown && $row->created_by == $my->id ) ) {
                           echo '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&task=edit&catid=$catid&navstart=".$params->navstart."&mode=".$params->mode."&id=".$row->id."&search=".$params->search). '" title="' ._E_EDIT. ' : ' .htmlspecialchars($row->title, ENT_NOQUOTES). '">';
                           echo '<img src="' .JURI::root(). 'images/M_images/edit.png" align="middle" border="0" alt="' ._E_EDIT. '" />';
                           echo '</a>';
                        } else {
                            echo '&nbsp;';
                        }
                        echo '</td>'."\n";
                     }

                     // *** Display each columns according to their order defined in Columns Editor...
                     foreach ($params->columns as $column) {

                       // *** Column : Icons
                       if ($column->name == "icon" && $column->visible ) {
                          echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosBookmarksTools::cssClass($params->cssbookmarksgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosBookmarksTools::cssClass($params->cssbookmarksbronze);
                          }
                          echo ' width="20" align="left" nowrap="nowrap">';
			  echo '<span class="editlinktip hasTip" title="'.$overlibtxt.'" style="max-width: 400px">';
                          echo $anchor;
                          echo '<img src="' .JURI::root(). 'components/com_bookmarks/images/html.png" border="0" alt="" />';
                          echo $anchorend."\n";
			  echo "</span>";
                       }

                       // *** Column : Bookmarks
                       if ($column->name == "bookmark" && $column->visible ) {
                          echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosBookmarksTools::cssClass($params->cssbookmarksgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosBookmarksTools::cssClass($params->cssbookmarksbronze);
                          }
                          echo ' width="';
                          echo ( mosBookmarksTools::isColVisible('description', $params->columns) && !$params->showdescsplit ) ? floor(45/($nbcols-$hidecols))."%" : floor(100/($nbcols-$hidecols))."%";
                          echo '"';
                          echo ' align="left">';
			  echo '<span class="editlinktip hasTip" title="'.$overlibtxt.'">';
                          echo $anchor;
                          echo htmlspecialchars($row->title, ENT_NOQUOTES);
                          echo $anchorend.' ';
 			  echo "</span>";

                          if ($params->showdetaillink == 2 || ($params->showdetaillink == 1 && $row->redirect != 1 && trim(strip_tags($row->detail)) ) ) {
                             echo '<a href="'. JRoute::_("index.php?option=$option&Itemid=$Itemid&catid=$catid&navstart=".$params->navstart."&task=detail&mode=".$params->mode."&id=".$row->id."&search=".$params->search). '">';
                             echo '<img src="' .JURI::root(). 'components/com_bookmarks/images/opendetail.png" border="0" alt="" title="'._BMU_OPEN_DETAIL.'" />';
                             echo '</a>&nbsp;';
                          }

                          if ( ($params->canrecommend==1 && $my->id) || $params->canrecommend==2 ) {
                             echo '<a href="'. JRoute::_("index.php?option=$option&Itemid=$Itemid&catid=$catid&navstart=".$params->navstart."&task=recommend&mode=".$params->mode."&id=".$row->id."&search=".$params->search). '">';
                             echo '<img src="' .JURI::root(). 'images/M_images/emailButton.png" border="0" alt="' ._BMU_RECOMMEND. '" title="'._BMU_RECOMMEND.'" />';
                             echo '</a>&nbsp;';
                          }

                          if ($row->ratingadmin) {
                             if ($row->ratingadmin == 1) { // Bronze
                                echo '<img src="' .JURI::root(). 'components/com_bookmarks/images/isbronze.png" border="0" alt="' ._BMU_ISBRONZE. '" title="'._BMU_ISBRONZE.'" />&nbsp;';
                             } else {  // Gold
                                echo '<img src="' .JURI::root(). 'components/com_bookmarks/images/isgold.png" border="0" alt="' ._BMU_ISGOLD. '" title="'._BMU_ISGOLD.'" />&nbsp;';
                             }
                          }

                          if ($params->showpoplast) {
                             $created = mosBookmarksTools::calcElapsedDays( $row->created );
                             if ($created->days <= $params->showpoplast) {
                                echo '<img src="' .JURI::root(). 'components/com_bookmarks/images/isnew.png" border="0" alt="' ._BMU_ISNEW. '" title="'._BMU_ISNEW.' ('.$created->days.' '._BM_DAYS.')" />&nbsp;';
                             }
                          }

                          if ($params->showpoptop && $params->canvote) {
                             if ($row->rating >= $params->showpoptop) {
                                echo '<img src="' .JURI::root(). 'components/com_bookmarks/images/istop.png" border="0" alt="' ._BMU_ISTOP. '" title="'._BMU_ISTOP.' ('.$row->rating.')" />&nbsp;';
                             }
                          }

                          if ($params->showpopbest) {
                             if ($row->hits >= $params->showpopbest) {
                                echo '<img src="' .JURI::root(). 'components/com_bookmarks/images/isbest.png" border="0" alt="' ._BMU_ISBEST. '" title="'._BMU_ISBEST.' ('.$row->hits.')" />&nbsp;';
                             }
                          }

                          if ( $row->url && ( $params->markvalidate == 2 || $params->markvalidate == 3 ) ) {
                             if ($params->validatefront && ( ( $access->canEdit ) || ( $access->canEditOwn ) || ( $params->regcaneditown && $my->id ) )) {
                                echo '<a href="'. JRoute::_("index.php?option=$option&Itemid=$Itemid&catid=$catid&navstart=".$params->navstart."&task=check&mode=".$params->mode."&id=".$row->id."&search=".$params->search). '">';
                             }
                             echo '<img src="'.$valid_img.'" border="0" title="'.mosBookmarksTools::SafeQuotes(strip_tags($valid_status), false).'" alt="" />';
                             if ($params->validatefront && ( ( $access->canEdit ) || ( $access->canEditOwn ) || ( $params->regcaneditown && $my->id ) )) {
                                echo '</a>';
                             }
                             echo '&nbsp;';
                          }

                          if ( $row->url && ($params->showpagerank == 2 || $params->showpagerank == 3) && $row->pagerank != -1) {
                             $rank_img = JURI::root(). 'components/com_bookmarks/images/gpr'. $row->pagerank .'s.png';
                             echo '<img src="' .$rank_img. '" border="0" title="'._BMU_PAGERANK.': '.$row->pagerank.'" alt="PR'.$row->pagerank.'" />&nbsp;';
                          }

                          if ( $row->private && ( $params->markprivate == 2 || $params->markprivate == 3 ) && $params->allowprivate ) {
                             echo '<span style="color: Red; font-weight: bold;" title="' ._BMU_PRIVATE. ' : '.$row->username.'">'._BMU_PRIVATE_MARK.'</span>&nbsp;';
                          }
                          echo ( $params->showdescsplit == 1 && mosBookmarksTools::isColVisible ('description', $params->columns) && trim(strip_tags($row->description)) ) ? "<br />".$row->description : "";

                          if ( $params->jreviews && defined('_BOOKMARKS_JREVIEWS') ) {
                             // *** jReviews Integration - new class defined at the bottom
                             $review = mosBookmarksTools::jReviewsRating($row->id, $catid, $params);
                             echo $review->rating_stars;
                             echo '&nbsp;';
                          }

                          echo '</td>'."\n";
                       }

                       // *** Column : Description
                       if ( $column->name == "description" && $column->visible && ( !$params->showdescsplit || ( !mosBookmarksTools::isColVisible ('bookmark', $params->columns) && $params->showdescsplit==1 ) ) ) {
                          echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosBookmarksTools::cssClass($params->cssbookmarksgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosBookmarksTools::cssClass($params->cssbookmarksbronze);
                          }
                          echo ' width="';
                          echo ( mosBookmarksTools::isColVisible('description', $params->columns) && !$params->showdescsplit ) ? floor(55/($nbcols-$hidecols))."%" : floor(100/($nbcols-$hidecols))."%";
                          echo '"';
                          echo ' align="left">';
                          echo ( trim(strip_tags($row->description)) ) ? $row->description : "&nbsp;";
                          echo '</td>'."\n";
                       }

                       // *** Column : Image
                       if ($column->name == "image" && $column->visible ) {
                          echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosBookmarksTools::cssClass($params->cssbookmarksgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosBookmarksTools::cssClass($params->cssbookmarksbronze);
                          }
                          echo ' width="';
                          echo ( !mosBookmarksTools::isColVisible ('bookmark', $params->columns) && !mosBookmarksTools::isColVisible ('description', $params->columns) ) ? floor(100/($nbcols-$hidecols)).'%' : '60';
                          echo '"';
                          if ($params->showimagesplit && $params->showdescsplit == 2) {
                             echo ' rowspan="2"';
                          }
                          echo ' align="left" nowrap="nowrap">';
                          if ( $row->imageurl && $picurl ) {
                             echo '<span class="editlinktip hasTip" title="'.$overlibtxt.'">';
                             echo $anchor;
                             echo '<img src="' .JRoute::_($picurl). '"';
                             if ($params->imgforcewidth) {
                                echo ' width="' .$params->imgforcewidth. '"';    // To force the image size...
                             }
                             if ($params->imgforceheight) {
                                echo ' height="' .$params->imgforceheight. '"';    // To force the image size...
                             }
// !!pic
//                             echo ' onload="if(this.width==1){this.width=\'120\';this.height=\'90\'}"';   // Thumbshot "Preview Not found" is 1x1 pixel => force to 120x90...
                             if ($params->imageeffectlst) {
                                echo ' '.$params->imageeffectlst;    // To add some extra parameters, like JS online effects
                             }
                             echo ' border="0" align="left" hspace="2" alt=""';
                             echo ' />';
                             echo $anchorend.'<br />';
                             echo "</span>";
                          } else {
                             echo '&nbsp;';
                          }
                          echo '</td>'."\n";
                       }

                       // *** Column : Rating
                       if ($params->canvote && $column->name == "rating" && $column->visible ) {
                          $disp = (($params->canvotedetail == 0 || $params->canvotedetail == 1) && $my->gid >= $params->votelevel) ? 1 : 0;
                          echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosBookmarksTools::cssClass($params->cssbookmarksgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosBookmarksTools::cssClass($params->cssbookmarksbronze);
                          }
                          echo ' width="';
                          if ($disp) {
                             switch ($params->showratingsplit) {
                               case "1" :
                                   echo '100';     // for stars above the vote button
                                   break;
                               case "2" :
                                   echo '60';      // for the all elements on the same line
                                   break;
                               case "0" :
                               default :
                                   echo '160';     // for elements on 3 lines
                             }
                          } else {                 // Not allowed to vote => Only Stars
                            echo '60';
                          }
                          echo '" align="center" nowrap="nowrap">'."\n";
                          echo mosBookmarksTools::displayRating ('rating', $row, $column, $params, true, $disp, $lists->rating);
                          echo '        </td>'."\n";
                       }


                       // *** Column : Hits
                       if ($column->name == "hits" && $column->visible ) {
                          echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosBookmarksTools::cssClass($params->cssbookmarksgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosBookmarksTools::cssClass($params->cssbookmarksbronze);
                          }
                          echo ' width="60" align="center" nowrap="nowrap">' .number_format($row->hits, 0, _BMU_FMT_DECIMAL, _BMU_FMT_THOUSAND). '&nbsp;</td>'."\n";
                       }

                       // *** Column : Date
                       if ($column->name == "created" && $column->visible ) {
                          echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosBookmarksTools::cssClass($params->cssbookmarksgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosBookmarksTools::cssClass($params->cssbookmarksbronze);
                          }
                          echo ' width="110" align="left" nowrap="nowrap">' .JHTML::_('date', $row->created, JText::_('DATE_FORMAT_LC3') ). '&nbsp;</td>'."\n";
                       }

                       // *** Column : Publisher
                       if ($column->name == "created_by" && $column->visible ) {
                           echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosBookmarksTools::cssClass($params->cssbookmarksgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosBookmarksTools::cssClass($params->cssbookmarksbronze);
                          }
                          echo ' width="60" align="left" nowrap="nowrap">';
                          echo ($row->username) ? $row->username : _BMU_GUEST;
                          echo '&nbsp;</td>'."\n";
                       }

                       if ($column->custom == 1 && $column->visible && ( $column->f_type != 8 || ($column->f_type == 8 && $params->canvote) ) ) {
                          $name = 'f_'.$column->name;
                          if ($column->f_type == 8) {
                             $disp = (($params->canvotedetail == 0 || $params->canvotedetail == 1) && $my->gid >= $params->votelevel) ? 1 : 0;
                             echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosBookmarksTools::cssClass($params->cssbookmarksgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosBookmarksTools::cssClass($params->cssbookmarksbronze);
                          }
                          echo ' width="';
                             if ($disp) {
                                switch ($params->showratingsplit) {
                                  case "1" :
                                      echo '100';     // for stars above the vote button
                                      break;
                                  case "2" :
                                      echo '60';      // for elements on 3 lines
                                      break;
                                  case "0" :
                                  default :
                                      echo '160';     // for the all elements on the same line
                                }
                             } else {                 // Not allowed to vote => Only Stars
                               echo '60';
                             }
                             echo '" align="center" nowrap="nowrap">'."\n";
                             echo mosBookmarksTools::displayCustom ($name, $row, $column, $params, true, $disp, $lists->$name);
                          } else {

                             echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosBookmarksTools::cssClass($params->cssbookmarksgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosBookmarksTools::cssClass($params->cssbookmarksbronze);
                          }
                          echo ' width="40" align="';
                             if ($column->f_type == 6 || $column->f_type == 7) {  //  "center" align for URL and Mail fields
                                echo 'center';
                             } else {
                                echo 'left';
                             }
                             echo '" nowrap="nowrap">';
                             echo mosBookmarksTools::displayCustom ($name, $row, $column, $params);
                             echo '&nbsp;';
                          }
                          echo '</td>'."\n";
                       }

                     } // Columns Loop

                     // *** add a special blank columns to push columns to left...
                     if ( !mosBookmarksTools::isColVisible('bookmark', $params->columns)
                          && (!mosBookmarksTools::isColVisible('description', $params->columns) || ( mosBookmarksTools::isColVisible('description', $params->columns) && $params->showdescsplit==1) )
                          && !mosBookmarksTools::isColVisible('image', $params->columns)
                        ) {
                        echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosBookmarksTools::cssClass($params->cssbookmarksgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosBookmarksTools::cssClass($params->cssbookmarksbronze);
                          }
                          echo ' width="'.floor(100/($nbcols-$hidecols)).'%" align="left" nowrap="nowrap">&nbsp;</td>'."\n";
                     }

                  } else {       // Display blank cells

                     if ($col <= (($nbcols-1) - $hidecols) ) {      // Should the column be displayed (not an empty one) ?

                        if ($col > 0) {       // Multiple cols ? Do not forget to add separator
                           echo '        <td width="17" nowrap="nowrap" style="padding-left: 6pt;padding-right: 6pt;background-image: url(' .JURI::root(). 'components/com_bookmarks/images/separator.png);">';
                           echo '</td>'."\n";
                        }

                        if ( ( $access->canEdit ) || ( $access->canEditOwn ) )
                                                                                    { echo '        <td width="17" nowrap="nowrap">&nbsp;</td>'."\n"; }
                        foreach ($params->columns as $column) {
                           if ($column->name == "icon" && $column->visible )        { echo '        <td width="20" nowrap="nowrap">&nbsp;</td>'."\n"; }
                           if ($column->name == "bookmark" && $column->visible )    { echo '        <td width="';
                                echo ( mosBookmarksTools::isColVisible('description', $params->columns) && !$params->showdescsplit ) ? floor(45/($nbcols-$hidecols))."%" : floor(100/($nbcols-$hidecols))."%";
                              echo '">&nbsp;</td>'."\n"; }
                           if ($column->name == "description" && $column->visible && !$params->showdescsplit ) { echo '        <td width="';
                              echo ( mosBookmarksTools::isColVisible ('bookmark', $params->columns) ) ? floor(55/($nbcols-$hidecols))."%" : floor(100/($nbcols-$hidecols))."%";
                              echo '">&nbsp;</td>'."\n"; }
                           if ($column->name == "image" && $column->visible)        { echo '        <td width="60" nowrap="nowrap">&nbsp;</td>'."\n"; }
                           if ($params->canvote && $column->name == "rating" && $column->visible ) {
                              echo '        <td width="';
                              echo ( $params->showratingsplit ) ? '120' : '60';
                              echo '" nowrap="nowrap">&nbsp;</td>'."\n";
                           }
                           if ($column->name == "hits" && $column->visible)         { echo '        <td width="60" nowrap="nowrap">&nbsp;</td>'."\n"; }
                           if ($column->name == "created" && $column->visible)         { echo '        <td width="60" nowrap="nowrap">&nbsp;</td>'."\n"; }
                           if ($column->name == "created_by" && $column->visible)    { echo '        <td width="60" nowrap="nowrap">&nbsp;</td>'."\n"; }

                           if ($column->custom == 1 && $column->visible && ( $column->f_type != 8 || ($column->f_type == 8 && $params->canvote) ) ) {
                              $name = 'f_'.$column->name;
                              if ($column->f_type == 8) {
                                 echo '        <td width="';
                                 switch ($params->showratingsplit) {
                                   case "1" :
                                       echo '100';     // for stars above the vote button
                                       break;
                                   case "2" :
                                       echo '60';      // for elements on 3 lines
                                       break;
                                   case "0" :
                                   default :
                                       echo '160';     // for the all elements on the same line
                                 }
                                 echo '" align="center" nowrap="nowrap">';
                              } else {
                                 echo '        <td width="60" align="left" nowrap="nowrap">';
                              }
                              echo '&nbsp;</td>'."\n";
                           }

                        }
                        if ( !mosBookmarksTools::isColVisible('bookmark', $params->columns)
                             && (!mosBookmarksTools::isColVisible('description', $params->columns) || ( mosBookmarksTools::isColVisible('description', $params->columns) && $params->showdescsplit==1) )
                             && !mosBookmarksTools::isColVisible('image', $params->columns)
                           ) {
                           echo '        <td width="'.floor(100/($nbcols-$hidecols)).'%" align="left" nowrap="nowrap">&nbsp;</td>'."\n";
                        }

                     }
                  }

              }

              echo '      </tr>'."\n";         // Close Row Tag


              // *** Display Description on 2nd line
              if ( mosBookmarksTools::isColVisible('description', $params->columns) && $params->showdescsplit == 2 ) {
                 echo '      <tr class="' .$tabclass[$alternate]. '">'."\n";

                 for ($col=0; $col <= (($nbcols-1) - $hidecols); $col++) {


                     $item = ($col*$nbrows) + $line;                      // Compute grid position

                     if ( $item < $items ) {
                        $row = $rows[$blocks[$block]->first+$item];       // Display item within block at correct grid position
                     } else {
                         unset($row);
                     }

                     if ($col > 0) {       // Multiple cols ? Do not forget to add separator
                        echo '        <td width="17" nowrap="nowrap" style="padding-left: 6pt;padding-right: 6pt;background-image: url(' .JURI::root(). 'components/com_bookmarks/images/separator.png);">';
                        echo '</td>'."\n";
                     }

                     // Edit icon column
                     if ( ( $access->canEdit ) || ( $access->canEditOwn ) || ( $params->regcaneditown && $my->id ) ) {
                        echo '        <td';
                          if ($item < $items && $row->ratingadmin == 2) {         // Gold
                            echo mosBookmarksTools::cssClass($params->cssbookmarksgold);
                          } elseif ($item < $items && $row->ratingadmin == 1) {
                            echo mosBookmarksTools::cssClass($params->cssbookmarksbronze);
                          }
                          echo ' width="17" >';
                        echo '&nbsp;</td>'."\n";
                     }

                     // *** Column : Description on a separate line... (ShowDescSplit = 1)
                     echo '        <td';
                          if ($item < $items && $row->ratingadmin == 2) {         // Gold
                            echo mosBookmarksTools::cssClass($params->cssbookmarksgold);
                          } elseif ($item < $items && $row->ratingadmin == 1) {
                            echo mosBookmarksTools::cssClass($params->cssbookmarksbronze);
                          }
                          echo ' colspan="'.$nbcol.'"';
                     echo ' width="';
                     echo ( mosBookmarksTools::isColVisible('description', $params->columns) && $params->showdescsplit ) ? floor(55/($nbcols-$hidecols))."%" : floor(100/($nbcols-$hidecols))."%";
                     echo '"';
                     echo ' align="left" valign="top">';

                     if ( $item < $items ) {
                        if ( $params->botsonbmdesc && mosBookmarksTools::isColVisible ('description', $params->columns) && trim(strip_tags($row->description)) ) {
                           // *** MosBot : The {MosImage} is no supported as the Images field is not present !!! => Need to use fixed path for images...
                           $row->text = $row->description;  // MosBot only uses field "text" => Need to copy "detail" content ...
                           $row->images = "";               // MosBot Need to simulate "images" field (must be present, but keep empty)
                           $row->sectionid = "";            // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
                           $page = 0;                       // MosBot pagination system
                           // Process the MosBots
                           //$results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
                           $results =  $mainframe->triggerEvent( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
                           $row->description = $row->text;   // Return Converted text...
                        }

                        if ($row->description) {
                           echo $row->description;
                        } else {
                           echo '&nbsp;';
                        }
                     } else {
                        echo '&nbsp;';
                     }

                     if ( $params->jreviews && defined('_BOOKMARKS_JREVIEWS') ) {
                        // *** jReviews Read More, Read Reviews, Add Reviews Links
                        echo '<span class="jr_read_more"><a href="'. JRoute::_("index.php?option=$option&Itemid=$Itemid&catid=$catid&navstart=".$params->navstart."&task=detail&mode=".$params->mode."&id=".$row->id."&search=".$params->search). '">Read More</a></span>';
                        echo '<span class="jr_add_review"><a href="'. JRoute::_("index.php?option=$option&Itemid=$Itemid&catid=$catid&navstart=".$params->navstart."&task=detail&mode=".$params->mode."&id=".$row->id."&search=".$params->search). '#user_reviews">Read Reviews ('.$review->review_count.')</a></span>';
                        echo '<span class="jr_read_reviews"><a href="'. JRoute::_("index.php?option=$option&Itemid=$Itemid&catid=$catid&navstart=".$params->navstart."&task=detail&mode=".$params->mode."&id=".$row->id."&search=".$params->search). '#user_reviews">Write Review</a></span>';
                     }

                     echo '</td>'."\n";

                 }

                 echo '      </tr>'."\n";  // Close Description row tag (2nd line)
              }

              // *** Display Bookmarks Separator (3rd line)
              if ( $params->showseparator ) {
                 echo '      <tr class="' .$tabclass[$alternate]. '">'."\n";

                 // *** Column : Description on a separate line... (ShowDescSplit = 1)
                 if ( ( $access->canEdit ) || ( $access->canEditOwn ) || ( $params->regcaneditown && $my->id ) ) {
                    $nc = $nbcol+1;
                 } else {
                    $nc = $nbcol;
                 }

                 for ($col=0; $col <= (($nbcols-1) - $hidecols); $col++) {

                     if ($col > 0) {       // Multiple cols ? Do not forget to add separator
                        echo '        <td width="17" nowrap="nowrap" style="padding-left: 6pt;padding-right: 6pt;background-image: url(' .JURI::root(). 'components/com_bookmarks/images/separator.png);">';
                        echo '</td>'."\n";
                     }

                     echo '        <td colspan="'.$nc.'">';
                     echo '<hr />';
                     echo '</td>'."\n";

                 }

                 echo '      </tr>'."\n";  // Close Separator row tag (3rd line)
              }


              if ($params->showalternate) {  // Alternate Color mode ON ?
                 $alternate = 1 - $alternate;  // Alternate row color
              }

            }  //  end Rows Loop

            echo '    </table>'."\n";

            echo '  </td></tr>'."\n";

            if ($params->showcatdesc == 1 || ( $params->showcatdesc == 2 && $params->mode == 0 ) || ( $params->showcatdesc == 3 && $params->mode == 2 ) ) {
               if ($params->showcatdescpos == 1) {
                 HTML_bookmarks::DisplayCatImageDesc($option, $Itemid, $bmcat, $params, $blocks);
               }
            }

          } // end any Rows to display ?

       } // end groups

  } else {  // Empty list => Nothing to display...

     echo '<!-- Colums Header -->'."\n";
     if ($params->shownoitemtitle) {
        echo '<!-- Search BackTo Index -->'."\n";
        if ($params->mode == 0) {
           $trow = $currentcat;       // User Current Cat as Cat Block
           $bmcat->id = $trow->id;
           $bmcat->cat = $trow->name;
           $bmcat->description = $trow->description;
           $bmcat->image = $trow->image;
           $bmcat->image_position = $trow->image_position;
           $bmcat->icon = $trow->icon;
           HTML_bookmarks::BackToIndexCat ($option, $Itemid, $bmcat, $params, $blocks );
        }
     }
     if ($params->shownoitemtitle == 1) {
        echo '  <tr><td>'."\n";
        echo '    <table class="contentpane" width="100%" border="0" cellspacing="0" cellpadding="1">'."\n";
        HTML_bookmarks::displayHeader ($option, $Itemid, $catid, $nbcols, $hidecols, $nbcol, $orderbycol, $orderbyupdown, $params, $access);
        echo '    </table>'."\n";
        echo '  </td></tr>'."\n";
     }

     if ($params->shownoitem == 1 || ( $params->shownoitem == 2 && $catid > -1 ) ) {
        echo '  <tr><td';
        if ($params->shownoitemtitle) { echo ' colspan="' .$nbcol.'"'; }
        echo '>';
        echo _BMU_NO_ITEM_FOUND;
        echo '</td></tr>'."\n";
     }
  }

  if ( count($rows) > 0 ) {  // Some Item(s) to display...
     switch ($params->mode) {  // Last line  : "Back to Top"
       case "0" :   // One Cat
           HTML_bookmarks::BackToIndexCat ($option, $Itemid, $bmcat, $params, $blocks, true );
           break;
       case "1" :   // Alpha Grouped
           HTML_bookmarks::BackToIndexAlpha ($option, $Itemid, $catid, $params, "", $blocks, true );
           break;
       case "2" :   // Cat Grouped
           HTML_bookmarks::BackToIndexCat ($option, $Itemid, $bmcat, $params, $blocks, true );
           break;
       case "3" :   // Cat Grouped
           HTML_bookmarks::BackToIndexCat ($option, $Itemid, $bmcat, $params, $blocks, true );
           break;
       default :    // Other
           break;
     }
  }

  if (($params->submitpos == 0 && ($params->cansubmit && $my->id >= $params->submitlevel) ) || ($params->catpos == 0 && $categories && $params->showcats) ) {
     echo '  <tr><td>&nbsp;</td></tr>'."\n";
  }

  // *** Show Navigator on BOTTOM
  echo '<!-- Navigator (Bottom) -->'."\n";
  if ($params->navigatorpos == '2' || $params->navigatorpos == '3') {
        HTML_bookmarks::ShowNavigator($option, $Itemid, $catid, $params);
//     echo '  <tr><td>&nbsp;</td></tr>'."\n";
  }


  // *** Show Submit New on BOTTOM
  echo '<!-- Submit New (Bottom) -->'."\n";
  if ($params->submitpos == '0') {
        HTML_bookmarks::ShowSubmit($option, $Itemid, $catid, $params);
  }

  // *** Show Categories on BOTTOM
  echo '<!-- Categories (Bottom) -->'."\n";
  if ($params->catpos == '0' && $params->mode == 0 && $params->showcats) {
     switch ($params->catdisplayorder) {
       case "1" :
           HTML_bookmarks::ShowCatsHoriz($option, $catid, $categories, $Itemid, $params);
           break;
       case "2" :
           HTML_bookmarks::ShowCatsTree($option, $catid, $categories, $Itemid, $params);
           break;
       case "0" :
       default :
           HTML_bookmarks::ShowCatsVert($option, $catid, $categories, $Itemid, $params);
     }
//     echo '  <tr><td>&nbsp;</td></tr>'."\n";
  }

  if ($params->showbackbutton) {
     echo '<!-- Back Button -->'."\n";
     echo '  <tr><td align="center"><span class="back_button"><a href="javascript:window.history.go(-1);"><b>'._BACK.'</b></a></span><br /></td></tr>'."\n";
  }

  HTML_bookmarks::_footer();

  $snap = $snaps->getActiv();
  if (
//       mosBookmarksTools::isColVisible('image', $params->columns) &&
       $params->showsnapshoterpic &&
       $snap->PIC_URL
      ) {
     echo "  <tr><td>" . $snap->PIC_URL . "</td></tr>\n";
  }

  echo '</table>'."\n";

  echo "\n".'<!-- ### END Component : Bookmarks (c) www.TEGDesign.ch '.mosBookmarks::getVersion().' ### -->'."\n\n";

}


/*
*********************
**                 **
**  EDIT BOOKMARK  **
**                 **
*********************
*/

/**
* Writes the edit form for new and existing record
*
* A new record is defined when <var>$row</var> is passed with the <var>id</var>
* property set to 0.
* @param mosBookmark The bookmark object
* @param string The html for the categories select list
* @param string The html for the ordering select list
*/
    function editBookmark( &$row, $option, &$lists, $catid, $Itemid, $mode, $search, $access, $navstart, &$params ) {
       global $_VERSION, $mainframe;
       $my =& JFactory::getUser();

       echo "\n".'<!-- ### START Component : Bookmarks (c) www.TEGDesign.ch '.mosBookmarks::getVersion().' ### -->'."\n\n";

       echo '<!-- ### START - Debug Info ### -->'."\n\n";
       echo '<!-- id          = ' .$my->id. ' -->'."\n";
       echo '<!-- cansubmit   = ' .$params->cansubmit. ' -->'."\n";
       echo '<!-- submitlevel = ' .$params->submitlevel. ' -->'."\n";
//       echo '<!--  = ' .. ' -->'."\n";
       echo "\n".'<!-- ### End - Debug Info ### -->'."\n\n";

       JFilterOutput::objectHTMLSafe( $row );

       // !!! Need to load the javascript routines if user is a simple visitor...
       // !!! As it is loaded by default only for registred users (normally Core Mambo only allows registered to submit).
       // !!! => Load it only if user is a visitor and he can submit and the WYSIWYG is enabled !
       if ( $my->id == 0 && ($params->cansubmit && $params->submitlevel == 0)  ) {
          echo '<!-- ### START Init Load JS Lib for Guest ### -->'."\n";
          // *** Check for Core JavaScript Library
          $isJSLibJ = file_exists(JPATH_SITE.'/includes/js/joomla.javascript.js');  // Look for Joomla Lib file

          // *** Load the Core JavaScript Library
          if ($isJSLibJ) {         // Joomla libary found
             echo '<!-- JS Library found : joomla.javascript.js -->'."\n";
             echo '<script language="javascript" type="text/javascript" src="' .JPATH_SITE. '/includes/js/joomla.javascript.js"></script>'."\n";
          } else {                  // None Found => ERROR !!!
             echo '<!-- JS Library Not found : ERROR !!! -->'."\n";
             echo '<span style="color:Red;Border:1pt;Border-Color:Red;Border-Style:Solid;Display:Block;Margin:0pt;Padding:4pt;background-color:cornsilk;">';
             echo '<b>Bookmarks : Error Detected !</b><br />=> Cannot load JavaScript Library for <b>Guest</b>. He will not be able to save the Bookmark due to JavaScript Errors...<br />=> Please check for missing Core file "<b>joomla.javascript.js</b>" in folder "<b>/includes/js/</b>" !';
             echo '</span>'."\n";
          }
          echo '<!-- ### END Init Load JS Lib for Guest ### -->'."\n";

/*
          if ( $params->descfulledit || $params->detailfulledit ) {
             //  Load Editor for Guest (if not already by template)
             echo "\n".'<!-- ### START Init Editor for Guest ### -->'."\n";
             echo "\n".'<!-- ### END Init Editor for Guest ### -->'."\n\n";
          }
*/
       } else {
          echo '<!-- ### Registered user => Editor should already be Loaded ### -->'."\n";
       }
        jimport('joomla.html.editor');         // Import Editor Library
        $editor =& JFactory::getEditor();      // Init Editor Object

        jimport('joomla.html.pane');           // Import Multi-Panes Library
        $tabs =& JPane::getInstance('tabs');   // Init Pane Object

?>
<style type="text/css" title="">
/* tabs */
dl.tabs {
   float: left;
   margin: 10px 0 -1px 0;
   z-index: 50;
}

dl.tabs dt {
   color: Black;
   background: White;
   float: left;
   padding: 3px 10px;
   border-left: 1px solid #ccc;
   border-right: 1px solid #ccc;
   border-top: 1px solid #ccc;
   margin-left: 0px;
}

dl.tabs dt.open {
   color: White;
   background: #0099FF;
   border-bottom: 1px solid #F9F9F9;
   z-index: 100;
}

div.current {
   clear: both;
   border: 1px solid #ccc;
   padding: 10px 10px;
}

div.current dd {
   padding: 0;
   margin: 0;
}
</style>
<?php

        JHTML::_('behavior.calendar');         // Add the Calendar includes to the document <head> section
 ?>

<?php /* // if ($params->allowdate || $my->usertype == "Super Administrator") {  // Allow to edit Creation date in front-end - Admins will always be able to do it ?>
        <link rel="stylesheet" type="text/css" media="all" href="<?php echo JUri::base(true);?>/includes/js/calendar/calendar-mos.css" title="green" />
        <!-- import the calendar script -->
        <script type="text/javascript" src="<?php echo JUri::base(true);?>/includes/js/calendar/calendar.js"></script>
        <!-- import the language module -->
        <script type="text/javascript" src="<?php echo JUri::base(true);?>/includes/js/calendar/lang/calendar-en.js"></script>
<?php // } */  ?>

        <script language="javascript" type="text/javascript">
        function OpenWin(URL) {
           if (URL == '') {
<?php if ($params->checkemptyurl) {  // Check for empty Url ?>
              alert( "<?php echo _BM_BOOKMARK_MUST_HAVE_URL; ?>" );
<?php } ?>
           } else {
              protocols = new Array();
<?php
              $protocols = split( ",", mosBookmarksTools::getPref(-1,'params','protocols', _BM_PROTOCOLS) );
              // *** List the valid protocols...
              foreach ($protocols as $protocol) {
                 echo '              protocols.push ("' .$protocol. '");'."\n";
              }
?>
              if (URL) {  // if not empty, check for valid protocol
                 prot = false;
                 for (i=0; i<protocols.length; i++) {
                    if ( URL.indexOf(protocols[i]) >= 0 ) {
                       prot = true;
                    }
                 }
                 if ( !prot ) { URL = "http://"+URL; }  // Protocol missing or not in the list => add "http://"
              }

              // *** Relace Keywords with info : UID, UNAME and MORE
              URL = URL.replace(/##MORE##/,'<?php echo $params->keywordmore; ?>');
              URL = URL.replace(/##UID##/,'<?php echo $my->id; ?>');
              URL = URL.replace(/##UNAME##/,'<?php echo $my->username; ?>');

              win  = window.open(URL, null); // Just specify "Null" to open a new default window...
           }
        }
        </script>

        <script language="javascript" type="text/javascript">
        function submitbutton(pressbutton) {
            var form = document.adminForm;
            if (pressbutton == 'cancel') {
                submitform( pressbutton );
                return;
            }

            // *** do field validation
            if (form.title.value == ""){
                alert( "<?php echo _BM_BOOKMARK_MUST_HAVE_TITLE; ?>" );
<?php if ($params->checkemptyurl) {  // Check for empty Url ?>
            } else if (form.url.value == ""){
                alert( "<?php echo _BM_BOOKMARK_MUST_HAVE_URL; ?>" );
<?php } ?>
            } else {
<?php
       if ($params->descfulledit || $my->usertype == "Super Administrator") {  // Allowed to use the full editor to edit the description
               echo $editor->save( 'descriptions' );
       }
       if ( ($params->detailfulledit && $params->allowdetail) || $my->usertype == "Super Administrator" ) {  // Allowed to enter details in front-end - Admins will always be able to enter details
               echo $editor->save( 'detail' );
       }
?>
                submitform( pressbutton );
            }
        }
        </script>

<?php     // *** MosBot : Convert "$params" to "JParameter" format
     $prms = "";
     $bmparams =& new JParameter( $prms );   // Use "$botparms" to avoid overwritting "$params" (from Module)
     foreach ($params as $k=>$v) {
        $bmparams->def($k,$v);
     }

     echo '<!-- Component Header -->'."\n";
     if ($params->comheadersubmit && $params->botsonheadersubmit) {         // Field : Header Wrapper
        // *** Init MosBots (loading "Content" related bots)
        // *** MosBot : The {MosImage} is no supported as the Images field is not present !!! => Need to use fixed path for images...
        $row->images = "";                      // MosBot Need to simulate "images" field (must be present, but keep empty)
        $page = 0;                              // MosBot pagination system
        $row->sectionid = "";                   // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
        //$_MAMBOTS->loadBotGroup( 'content' );   // Load published Bots from "Content" folder
        JPluginHelper::importPlugin( 'content' );   // Load published Bots from "Content" folder
        // *** Process the MosBots
        $row->text = $params->comheadersubmit;  // MosBot only uses field "text" => Need to copy "detail" content ...
        //$results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
        $results =  $mainframe->triggerEvent( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
        $params->comheadersubmit= $row->text;
     }

     echo '<div class="contentpane">';
     echo $params->comheadersubmit;
     echo '</div>';


/*
foreach ($row as $k=>$v) {
  echo "DEBUG: $k: $v<br />\n";
  if (substr($k,0,2)=="f_") {
     echo "DEBUG : ... <b>$k</b> ";
     foreach ($v as $x=>$y) {
       echo "| $x: $y ";
     }
     echo "<br />\n";
  }
}
*/

/*
echo "DEBUG: AllowPrivate : ".$params->allowprivate."<br />\n";
echo "DEBUG: ForcePrivate : ".$params->forceprivate."<br />\n";
echo "DEBUG: Private : ".$row->private."<br />\n";
echo "DEBUG: User : ".$my->username."<br />\n";
echo "DEBUG: id : ".$my->id."<br />\n";
echo "DEBUG: gid : ".$my->gid."<br />\n";
echo "DEBUG: usertype : ".$my->usertype."<br />\n";

foreach ($my as $k=>$v) {
  echo "DEBUG: MY : $k: $v<br />\n";
}

foreach ($access as $k=>$v) {
  echo "DEBUG: ACCESS : $k: $v<br />\n";
}
*/

?>

        <table cellspacing="0" border="0" width="100%">
          <tr>
            <td width="60%"><span class="contentheading"><?php echo $row->id ? _BM_EDIT : _BM_ADD;?> <?php echo _BMU_BOOKMARK; ?></span></td>
            <td width="40%">
		<div style="float: right;">
			<button type="button" onclick="submitbutton('save')"><?php echo _BMU_SAVE; ?></button>
			<button type="button" onclick="submitbutton('cancel')"><?php echo _BMU_CANCEL; ?></button>
		</div>

<?php
/*
   // *** Action Buttons
            mosToolBar::startTable();
            mosToolBar::spacer();
            mosToolBar::save();
            mosToolBar::spacer(25);
            mosToolBar::cancel();
            mosToolBar::endtable();
*/
?>
            </td>
          </tr>
        </table>

        <form action="<?php echo JRoute::_('index.php?option=' .$option. '&Itemid=' .$Itemid. '&mode=' .$mode. '&catid=' .$catid. '&navstart=' .$navstart. '&search='.$search); ?>" method="post" name="adminForm" id="adminForm">

        <table cellspacing="0" border="0" width="100%" class="adminform">

            <tr valign="top">
                <td width="10%" nowrap="nowrap" align="right"><?php echo _BM_NAME; ?>:</td>
                <td width="90%">
                    <input class="inputbox" type="text" name="title" size="50" maxlength="250" value="<?php echo $row->title;?>" />
                </td>
            </tr>
<?php if ($params->submitwithurl) { ?>
             <tr valign="top">
                 <td align="right" nowrap="nowrap"><?php echo _BM_URL; ?>:</td>
                 <td>
                     <table border="0" cellspacing="0" cellpadding="0">
                       <tr valign="top">
                       <td><input class="inputbox" type="text" name="url" value="<?php echo $row->url; ?>" size="50" /></td>
                       <td><img src="<?PHP echo JURI::root(); ?>components/com_bookmarks/images/html.png" hspace="5" title="<?php echo _BMU_TEST_URL; ?>" alt="URL" onclick="OpenWin(document.adminForm.url.value); return false" /></td>
                       </tr>
                     </table>
                 </td>
             </tr>
<?php } ?>
          </table>
<?php
           echo $tabs->startPane("edit-params");

           echo $tabs->startPanel(_BM_CATEGORY,"cat-page");
  ?>
        <table cellspacing="0" border="0" width="100%" class="adminform">
<?php
   // if ( !$params->submitcat || $my->usertype == "Super Administrator" ) {  // Hide the Category Selector for all users except for Admin
   // if ( !$params->submitcat || ( $params->submitcat &&  ) || $my->usertype == "Super Administrator" ) {  // Hide for All Users except for Publisher/Admin
   // if ( !$params->submitcat || ( $params->submitcat && $access->canEdit ) || $my->usertype == "Super Administrator" ) {     // Hide for All Users except for Editor/Publisher/Admin
      if ( !$params->forceaddcat || ( $params->forceaddcat && ( $access->canEditOwn || $access->canEdit ) ) || $my->usertype == "Super Administrator" ) {  // Hide only for Public or Registered, but not for Author/Editor/Publisher/Admin
?>
            <tr valign="top">
                <td align="right" nowrap="nowrap"><?php echo _BM_CATEGORY; ?>:</td>
                <td>
                    <?php echo $lists->clist; ?><br />
                    <?php echo (!$params->catselectorsingle) ? _BMU_MULTISELECT_HELP : ""; ?><br />
                </td>
            </tr>
<?php } ?>

          </table>
        <br />
<?php

       echo $tabs->endPanel();

       if ($params->allowdesc || $params->allowdetail || $my->usertype == "Super Administrator" ) {

          echo $tabs->startPanel(_BM_EDITOR_ADMIN_DESCRIPTION,"Desc-page");
?>

        <table cellspacing="0" border="0" width="100%" class="adminform">

<?php if ($params->allowdesc || $my->usertype == "Super Administrator") {  // Allow to enter details in front-end - Admins will always be able to do it ?>

<?php    if ($params->allow_getmeta || $my->usertype == "Super Administrator") {  // Allowed to retrieve MetaTag "Description" - Admins will always be able to do it ?>
            <tr valign="top">
                <td align="right" nowrap="nowrap"><?php echo _BM_GETMETA ?>:</td>
                <td>
                    <?php echo $lists->getmetalist; ?>
                </td>
            </tr>

<?php    } ?>
<?php if ($params->allowdetail || $my->usertype == "Super Administrator") {  // Allow to enter details in front-end - Admins will always be able to do it ?>
            <tr valign="top">
                <td align="right" nowrap="nowrap"><?php echo _BM_REDIRECT ?>:</td>
                <td>
                    <?php echo $lists->redirlist; ?>
                </td>
            </tr>

<?php } ?>
            <tr valign="top">
                <td width="10%" align="right" nowrap="nowrap"><?php echo _BM_SHORT_DESCRIPTION; ?>:</td>
                <td width="90%">
<?php    if ($params->descfulledit || $my->usertype == "Super Administrator") {  // Allowed to use the full editor to edit the description ?>
<?php
                // parameters : areaname, content, width, height, rows, cols
                echo $editor->display( 'descriptions', $row->description, $params->desceditwidth, $params->desceditheight, $params->descboxwidth, $params->descboxheight );
?>
<?php    } else { ?>
                <textarea name="descriptions" cols="<?php echo $params->descboxwidth; ?>" rows="<?php echo $params->descboxheight; ?>"><?php echo $row->description; ?></textarea>
<?php    } ?>
<?php    if (_BM_SHORT_DESCRIPTION_HELP) { ?>
                <br />
                <?php echo _BM_SHORT_DESCRIPTION_HELP; ?>
<?php    } ?>
                </td>
            </tr>

<?php } ?>
<?php if ($params->allowdetail || $my->usertype == "Super Administrator") {  // Allow to enter details in front-end - Admins will always be able to do it ?>
            <tr valign="top">
                <td align="right" nowrap="nowrap"><?php echo _BM_DETAIL; ?>:</td>
                <td>
<?php    if ($params->detailfulledit || $my->usertype == "Super Administrator") {  // Allowed to use the full editor to edit the detail ?>
<?php
                // parameters : areaname, content, width, height, rows, cols
                echo $editor->display( 'detail', $row->detail, $params->desceditwidth, $params->desceditheight, $params->descboxwidth, $params->descboxheight );
?>
<?php    } else { ?>
                <textarea name="detail" cols="<?php echo $params->descboxwidth; ?>" rows="<?php echo $params->descboxheight; ?>"><?php echo $row->description; ?></textarea>
<?php    } ?>
<?php    if (_BM_DETAIL_HELP) { ?>
                <br />
                <?php echo _BM_DETAIL_HELP; ?>
<?php    } ?>
                </td>
            </tr>

<?php } ?>
        </table>

<?php
          echo $tabs->endPanel();

      }


      // *** Check if there are some Custom Fields to display, if none hide the pane...
      $isCustomFields = false;
      foreach ($row as $name=>$obj) {
         if (substr($name,0,2)=='f_' && $obj->visibleedit && $obj->f_type != 8) { // is custom field, visible in editor and Not Rating type ?
            $isCustomFields = true;
         }
      }

      // *** Display the "Custom Fields" tab
      if ($isCustomFields) {    // Hide the pane if there are no parameters (Guest will only have the Creation Date)

         echo $tabs->startPanel(_BM_EDITOR_ADMIN_CUSTOM,"custom-page");

?>

           <table cellspacing="0" border="0" width="100%" class="adminform">
<?php
                 // *** Display Custom Fields
                 foreach ($row as $name=>$obj) {
                    if (substr($name,0,2)=='f_' && $obj->visibleedit && $obj->f_type != 8) {
                       echo '           <tr valign="top">';
                       echo '<td width="10%" align="right" nowrap="nowrap">';
                       echo $obj->title.':';
                       echo '</td>';
                       echo '<td width="90%">';
                       echo $lists->$name;
                       echo '</td>';
                       echo '</tr>'."\n";
                    }
                 }
?>
           </table>

<?php
         echo $tabs->endPanel();
      }

      // *** Check if there are some Parameters to display, if none hide the pane...
      $txt = '';
      $pcount = 0;

      if ($my->id && ($params->submitauto == 0 || ($params->submitauto && $row->id > 0) ) ) {  // Allow Registered Users to Approve in front-end (but only when editing) - Hidden for Guests
         $txt .= '                <tr valign="top">'."\n";
         $txt .= '                   <td width="10%" align="right" nowrap="nowrap">'._BM_APPROVED.':</td>'."\n";
         $txt .= '                   <td width="90%">'."\n";
         $txt .= $lists->applist;
         $txt .= '                   </td>'."\n";
         $txt .= '               </tr>'."\n";
         $pcount++;
      }

      if ( ($my->id && $access->canPublish) || $my->usertype == "Super Administrator") {  // Allow Publisher & Administrators to Publish in front-end  - Hidden for Guests and Registered
         $txt .= '               <tr valign="top">'."\n";
         $txt .= '                   <td width="10%" align="right" nowrap="nowrap">' ._BM_PUBLISHED. ':</td>'."\n";
         $txt .= '                   <td width="90%">'."\n";
         $txt .= $lists->publist;
         $txt .= '                   </td>'."\n";
         $txt .= '               </tr>'."\n";
         $pcount++;
      }

      if ( ( $my->id && $params->allowprivate && !$params->forceprivate ) || $my->usertype == "Super Administrator" ) {  // Allow Registered (registered=1) to keep bookmark Private in front-end - Hidden for Guests
         $txt .= '               <tr valign="top">'."\n";
         $txt .= '                   <td width="10%" align="right" nowrap="nowrap">' ._BM_PRIVATE. ':</td>'."\n";
         $txt .= '                   <td width="90%">'."\n";
         $txt .= $lists->privlist . '&nbsp;&nbsp;<b>'.$row->username.'</b>'."\n";
         $txt .= '                   </td>'."\n";
         $txt .= '               </tr>'."\n";
         $pcount++;
      }

      if ($params->allowdate || $my->usertype == "Super Administrator") {  // Allow to edit Creation date in front-end - Admins will always be able to do it
         $txt .= '               <tr valign="top">'."\n";
         $txt .= '                   <td width="10%" align="right" nowrap="nowrap">' ._BM_CREATION_DATE. ':</td>'."\n";
         $txt .= '                   <td width="90%">'."\n";
	 $txt .= JHTML::_('calendar', $row->created, 'created', 'created', '%Y-%m-%d %H:%M:%S', array('class'=>'inputbox', 'size'=>'25',  'maxlength'=>'19'));
         $txt .= '                   </td>'."\n";
         $txt .= '               </tr>'."\n";
         $pcount++;
      }
      if ($my->usertype == "Super Administrator") {  // Allow to edit the Admin Rating (Std, Bronze or Gold) - Only for Admins !
         $txt .= '               <tr valign="top">'."\n";
         $txt .= '                   <td width="10%" align="right" nowrap="nowrap">' ._BM_ADMIN_RATING. ':</td>'."\n";
         $txt .= '                   <td width="90%">'."\n";
         $txt .= $lists->ratingadm;
         $txt .= '                   </td>'."\n";
         $txt .= '               </tr>'."\n";
         $pcount++;
      }
     if ($my->usertype == "Super Administrator") {  // Allow to edit the Validation Method (Automatic or Manual) - Only for Admins !
         $txt .= '            <tr valign="top">'."\n";
         $txt .= '                <td align="right" nowrap="nowrap">' ._BM_VALIDATION. ':</td>'."\n";
         $txt .= '                <td>'."\n";
         $txt .= $lists->validlist;
         $txt .= '                </td>'."\n";
         $txt .= '            </tr>'."\n";
         $pcount++;
      }


      // *** Display the "Parameters" tab
      if ($pcount)  {    // Hide the pane if there are no parameters (Guest will only have the Creation Date)

         echo $tabs->startPanel(_BM_EDITOR_ADMIN_PARAMS,"params-page");

         echo '<table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminform">'."\n";
         if ($pcount) {  // Some params to display ?
            echo $txt;
         }
         echo '</table>'."\n";

         echo $tabs->endPanel();

      }

      echo $tabs->endPane();
?>

<?php if (!$params->allow_getmeta) {  // Allowed to retrieve MetaTag "Description" ?>
        <input type="hidden" name="allow_getmeta" value="0" />
<?php } ?>

        <input type="hidden" name="option" value="<?php echo $option;?>" />
        <input type="hidden" name="id" value="<?php echo $row->id; ?>" />
        <input type="hidden" name="created_by" value="<?php echo $row->created_by; ?>" />
        <input type="hidden" name="catid" value="<?php echo $catid; ?>" />
        <input type="hidden" name="Itemid" value="<?php echo $Itemid; ?>" />
        <input type="hidden" name="task" value="" />
        <?php echo JHTML::_( 'form.token' ); ?>
        </form>

        <table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminform">
<?php
        HTML_bookmarks::_footer(2);
?>
        </table>

<?php

    echo "\n".'<!-- ### END Component : Bookmarks (c) www.TEGDesign.ch '.mosBookmarks::getVersion().' ### -->'."\n\n";

    }


// ************************
// *** SHOW DETAIL PAGE ***
// ************************

function detailBookmark (&$row, $option, &$lists, $catid, $Itemid, $mode, $pathcat, $search, $access, &$params) {
  global $mainframe;
  global $snaps;
  $my =& JFactory::getUser();

  echo "\n".'<!-- ### START Component : Bookmarks (c) www.TEGDesign.ch '.mosBookmarks::getVersion().' ### -->'."\n\n";

  $params->_Itemid = $Itemid;
  $params->_option = $option;
  $params->_catid = $catid;
  $params->search = $search;
  $params->mode = $mode;

  $ishaloscan = false;

  if ($params->haloscansystem && $params->haloscanuser) {
     $ishaloscan = true;
     echo '<!-- Loading script for HaloScan comment system with User : '.$params->haloscanuser.'  -->'."\n";
     echo '
<script type="text/javascript">
var hs = new Array();
function myCount(id){
  if (hs[id]){
    if (hs[id] == 1){
       document.write(" (1)");
    } else {
       document.write("s (" + hs[id] + ")" );
    }
  } else {
    document.write(" (0)");
  }
}
</script>
';
     echo '<script type="text/javascript" src="http://www.haloscan.com/load/'.$params->haloscanuser.'"></script>'."\n\n";
  }

   // *** Show Pathway
   echo '<!-- Pathway -->'."\n";
   if ($catid && ($params->showpathway == 1 || $params->showpathway == 2) ) {
      echo '' .$pathcat. '<br />'."\n";
   }

/*
foreach ($params as $k=>$v) {
  echo "DEBUG: $k: $v<br />\n";
}
echo "DEBUG: 2 catid : ".$catid."<br />\n";
*/

  // MosBot : Convert "$params" to "JParameter" format
  $prms = "";
  $bmparams =& new JParameter( $prms );   // Use "$botparms" to avoid overwritting "$params" (from Module)
  foreach ($params as $k=>$v) {
     $bmparams->def($k,$v);
  }

  $snap = $snaps->getActiv();

  // *** Prepare Image url (compute link)
  if ( !( eregi("^http://", $row->imageurl) || eregi("^https://", $row->imageurl) || eregi("^func://", $row->imageurl) ) ) {   // Internal image (not HTTP, HTTPS or FUNC) ?
     $picurl = JUri::base(true). '/images/stories/' .$row->imageurl;    // Internal image from Images/Stories
  } else {
     $picurl = $row->imageurl;                                              // External image (use url)
     if ( eregi("^func://", $picurl) ) {   // Verify if there is a FUNC to process
        $func = substr($picurl,7);
              $func = '$picurl='.str_replace($params->urlkey,"'".$row->url."'",$func);
        eval($func);   // Compute function
     } else {
        if ( eregi($params->urlkey, $picurl) ) {                               // is the URL Keyword present ?
           $picurl = str_replace($params->urlkey, $row->url, $picurl);         // replace the "URL Keyword" with the URL...
        }
     }
     if ($picurl) {                                                         // Increment counter as we displayed a snapshot preview image to display service icon.
         $snap_items = split("[?(]", $snaps->systems[$params->snapshotactiv]->URL);
         if ( strpos(strtolower($row->imageurl), strtolower($snap_items[0])) !== false ) {
            if (isset($params->showsnapshoterpic)) {   // var initialization
               $params->showsnapshoterpic++;
            } else {
               $params->showsnapshoterpic = 1;        // first time increment
            }
        }
     }
  }



  // *** Build URL according to Redirection and OpenWin
  if ($row->url != "") {
    if ($params->directurl) {                 // Use direct URL => Not Hits Count !!!!

       // *** Relace Keywords with info : UID, UNAME and MORE
       $row->url = str_replace("##MORE##",$params->keywordmore,$row->url);
       $row->url = str_replace("##UID##",$my->id,$row->url);
       $row->url = str_replace("##UNAME##",$my->username,$row->url);

       $anchor = '<a href="' .$row->url. '"';
    } else {
       if ($row->openwin == 2) {              // Open url in Wrapper
          $anchor = '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&task=wrapper&id=".$row->id). '"';
       } else {
          $anchor = '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&task=view&id=".$row->id). '"';
       }
    }
    if ($row->openwin == 1) {                 // Open url in a blank page
       $anchor .= ' target="_blank"';
    }
    if ($row->openwin == 0) {                 // Open url in the parent page
       $anchor .= ' target="_parent"';
    }
    $anchor .= mosBookmarksTools::cssClass($params->cssbookmarks);
    $anchor .= '>';
    $anchorend = '</a>';
  } else {                                    // No URL => No redirection...
    if ($params->emptyurlnolink) {
      $anchor = '<span '.mosBookmarksTools::cssClass($params->cssbookmarks).'>';
      $anchorend = '</span>';
    } else {
      $anchor = '<a href="javascript:void(0);"'.mosBookmarksTools::cssClass($params->cssbookmarks).'>';
      $anchorend = '</a>';
    }
  }

  // *** Init MosBots (loading "Content" related bots)
  if ( ($params->comheaderdetail && $params->botsonheaderdetail) || $params->botsonbmdetail || $params->botsonbmdesc || $params->botsondetailads || $params->botsoncustommail) {
     // *** MosBot : The {MosImage} is no supported as the Images field is not present !!! => Need to use fixed path for images...
     $row->images = "";                      // MosBot Need to simulate "images" field (must be present, but keep empty)
     $row->sectionid = "";                   // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
     $page = 0;                              // MosBot pagination system
     //$_MAMBOTS->loadBotGroup( 'content' );   // Load published Bots from "Content" folder
     JPluginHelper::importPlugin( 'content' );   // Load published Bots from "Content" folder
  }

  if ( $params->botsoncustommail) {  // process Bots on Custom field "Mail" for adress obfuscation...
     foreach ($params->columns as $column) {
        if ($column->custom == 1 && $column->visible && $column->f_type == 7 ) {  // Only on "Mail" field
           $name = 'f_'.$column->name;
           // Process the MosBots
           $row->text = $row->$name;  // MosBot only uses field "text" => Need to copy "detail" content ...
           //$results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
           $results =  $mainframe->triggerEvent( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
           $row->$name = $row->text;   // Return Converted text...
        }
     }
  }

  echo '<table cellpadding="2" cellspacing="0" border="0" width="100%" class="adminform">'."\n";
  echo '<tr valign="top">';
  echo '<td';
  //if ( trim(strip_tags($params->detailads)) ) {
  if ( $params->detailads ) {
     echo ' colspan="2"';
  }
  echo '>';

  echo '<!-- Page Title -->'."\n";
  if ($params->detailshowpagetitle) {
     echo (_BMU_BOOKMARK_DETAIL) ? '<div class="componentheading">'._BMU_BOOKMARK_DETAIL.'<br /></div>'."\n" : "";
  }

  echo '<!-- Component Header -->'."\n";
  if ($params->comheaderdetail) {
     if ($params->botsonheaderdetail) {         // Field : Header Detail
        // *** Process the MosBots
        $row->text = $params->comheaderdetail;  // MosBot only uses field "text" => Need to copy "detail" content ...
        //$results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
        $results =  $mainframe->triggerEvent( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
        $params->comheaderdetail = $row->text;
     }
     echo '<div class="contentpane">';
     echo $params->comheaderdetail;
     echo '</div>';
  }

  // *** Process the MosBots, only if set to be performed !
  if ($params->botsonbmdetail) {            // Field : Detail
     $row->text = $row->detail;             // MosBot only uses field "text" => Need to copy "detail" content ...
     //$results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
     $results =  $mainframe->triggerEvent( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
     $row->detail = $row->text;            // Return converted text
  }

  if ($params->botsonbmdesc) {              // Field : Description
     $row->text = $row->description;        // MosBot only uses field "text" => Need to copy "detail" content ...
     //$results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
     $results =  $mainframe->triggerEvent( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
     $row->description = $row->text;        // Return converted text
  }

  if ($params->botsondetailads) {           // Field : Description
     $row->text = $params->detailads;       // MosBot only uses field "text" => Need to copy "detail" content ...
     //$results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
     $results =  $mainframe->triggerEvent( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
     $params->detailads = $row->text;       // Return converted text
  }

  echo '<!-- Bookmarks Popup Script -->'."\n";
  mosBookmarksTools::bm_popup($params);   // Load Bookmarks popup script

  echo '<!-- Custom Field Popup Script -->'."\n";
  mosBookmarksTools::f_popup($params);   // Load Custom Fields popup script

  echo '</td></tr>';

  echo '<!-- Page Detail -->'."\n";
  echo '<tr valign="top">';
  echo '<td>';
  echo '<table cellpadding="2" cellspacing="0" border="0" width="100%" class="adminform">'."\n";

  if ($params->detailshowtitles) { // Force size of the first column
     echo '  <tr>';
     echo '<td width="100"></td>';
     echo '<td></td>';
     echo '</tr>'."\n";
  }

  if (mosBookmarksTools::isColVisible( 'bookmark', $params->columns, 'detail' )) {
     echo '  <tr valign="top">';
     if ($params->detailshowtitles) {
        echo '<td nowrap="nowrap"><b>'. _BMU_URL. '</b>&nbsp;:&nbsp;</td>';
     }
     echo '<td>'."\n";
     echo '<span class="contentheading">'."\n";

     if ( mosBookmarksTools::isColVisible( 'icon', $params->columns, 'detail' ) ) {
        echo $anchor;
        echo '<img src="' .JURI::root(). 'components/com_bookmarks/images/html.png" border="0" alt="" />';
        echo $anchorend."\n";
     }
     echo $anchor;
     echo htmlspecialchars($row->title, ENT_NOQUOTES);
     echo $anchorend."\n";
     echo '</span>'."\n";

     if ( ($params->canrecommend==1 && $my->id ) || $params->canrecommend==2 ) {
        echo '<a href="'. JRoute::_("index.php?option=$option&Itemid=$Itemid&catid=$catid&navstart=".$params->navstart."&task=recommendd&mode=".$params->mode."&id=".$row->id."&search=".$params->search). '">';
        echo '<img src="' .JURI::root(). 'images/M_images/emailButton.png" border="0" alt="' ._BMU_RECOMMEND. '" title="'._BMU_RECOMMEND.'" />';
        echo '</a>&nbsp;';
     }

     // *** Admin Rating
     if ($row->ratingadmin) {
        if ($row->ratingadmin == 1) {   // Bronze
           echo '<img src="' .JURI::root(). 'components/com_bookmarks/images/isbronze.png" border="0" alt="' ._BMU_ISBRONZE. '" title="'._BMU_ISBRONZE.'" />&nbsp;';
        } else {                        // Gold
           echo '<img src="' .JURI::root(). 'components/com_bookmarks/images/isgold.png" border="0" alt="' ._BMU_ISGOLD. '" title="'._BMU_ISGOLD.'" />&nbsp;';
        }
     }

     // *** Popularity : New
     if ($params->showpoplast) {
        $created = mosBookmarksTools::calcElapsedDays( $row->created );
        if ($created->days <= $params->showpoplast) {
           echo '<img src="' .JURI::root(). 'components/com_bookmarks/images/isnew.png" border="0" alt="' ._BMU_ISNEW. '" title="'._BMU_ISNEW.' ('.$created->days.' '._BM_DAYS.')" />&nbsp;';
        }
     }

     // *** Popularity : Top Rated
     if ($params->showpoptop && $params->canvote) {
        if ($row->rating >= $params->showpoptop) {
           echo '<img src="' .JURI::root(). 'components/com_bookmarks/images/istop.png" border="0" alt="' ._BMU_ISTOP. '" title="'._BMU_ISTOP.' ('.$row->rating.')" />&nbsp;';
        }
     }

     // *** Popularity : Best Hits
     if ($params->showpopbest) {
        if ($row->hits >= $params->showpopbest) {
           echo '<img src="' .JURI::root(). 'components/com_bookmarks/images/isbest.png" border="0" alt="' ._BMU_ISBEST. '" title="'._BMU_ISBEST.' ('.$row->hits.')" />&nbsp;';
        }
     }

     // *** Edit Item
     if (  $access->canEdit || ( $access->canEditOwn && $row->created_by == $my->id ) || ( $params->regcaneditown && $row->created_by == $my->id ) || ( $my->usertype == "Super Administrator" ) ) {
//     if ( $access->canEdit || ( $access->canEditOwn && $row->created_by == $my->id) || $my->usertype == "Super Administrator" ) {
        echo '<a href="' .JRoute::_("index.php?option=$option&Itemid=$Itemid&task=edit&catid=$catid&navstart=".$params->navstart."&mode=".$params->displaymode."&id=".$row->id."&search=".$params->defaultsearch). '" title="' ._E_EDIT. ' : ' .htmlspecialchars($row->title, ENT_NOQUOTES). '">';
        echo '<img src="' .JURI::root(). 'images/M_images/edit.png" border="0" alt="' ._E_EDIT. '" />';
        echo '</a>';
     }

     echo '  </td>';
     echo '</tr>'."\n";
  }

  if ( mosBookmarksTools::isColVisible( 'image', $params->columns, 'detail' ) && $row->imageurl) {
     echo '  <tr valign="top">';
     if ($params->detailshowtitles) {
        echo '<td nowrap="nowrap"><b>'. _BMU_IMAGE. '</b>&nbsp;:&nbsp;</td>';
     }
     echo '<td>';
     echo $anchor;
     echo '<img src="' .JRoute::_($picurl). '"';
     if ($params->imgforcedetailwidth) {
        echo ' width="' .$params->imgforcedetailwidth. '"';    // To force the image size...
     }
     if ($params->imgforcedetailheight) {
        echo ' height="' .$params->imgforcedetailheight. '"';    // To force the image size...
     }
// !!pic2
//     echo ' onload="if (this.width<5) {this.src=\'/images/stories/noimage.png\'; this.width=\'120\'; this.height=\'90\'}"';      // Thumbshort trick to resize empty (1x1) image...
     if ($params->imageeffectdet) {
        echo ' '.$params->imageeffectdet;    // To add some extra parameters, like JS online effects
     }
     echo '  border="0" align="left" alt=""';
     echo ' />';
     echo $anchorend;
     echo '</td>';
     echo '</tr>'."\n";
  }

  if ( mosBookmarksTools::isColVisible( 'description', $params->columns, 'detail' ) && trim(strip_tags($row->description))) {
     echo '    <tr valign="top">';
     if ($params->detailshowtitles) {
        echo '<td nowrap="nowrap"><b>'. _BMU_SHORT_DESCRIPTION. '</b>&nbsp;:&nbsp;</td>';
     }
     echo '<td>'. $row->description. '</td>';
     echo '</tr>'."\n";
  }

  if (mosBookmarksTools::isColVisible( 'detail', $params->columns, 'detail' ) && trim(strip_tags($row->detail))) {
     echo '  <tr valign="top">';
     if ($params->detailshowtitles) {
           echo '<td nowrap="nowrap"><b>'. _BMU_DETAIL. '</b>&nbsp;:&nbsp;</td>';
     }
     echo '<td>'. $row->detail. '</td>';
     echo '</tr>'."\n";
  }

  if (mosBookmarksTools::isColVisible( 'category', $params->columns, 'detail' )) {
     echo '  <tr valign="top">';
     if ($params->detailshowtitles) {
        echo '<td nowrap="nowrap"><b>'. _BMU_CAT. '</b>&nbsp;:&nbsp;</td>';
     }
     echo '<td>';
     if (!$row->categories) {
        echo $row->category;
     } else {
        echo "\n".'<ul>'."\n";
        foreach ($row->categories as $catn) {
           $catn_items = preg_split ('/\|/', $catn);
           echo '    <li>';
           if ($params->detailcaturl) {
              echo '<a href="' .JRoute::_("index.php?option=$option&Itemid=".$Itemid."&catid=".$catn_items[0]). '" title="'._BM_CATEGORY.' : '.$catn_items[1].'">';
           }
           echo htmlspecialchars($catn_items[1], ENT_NOQUOTES);
           if ($params->detailcaturl) {
              echo '</a>';
           }
           echo "</li>"."\n";
        }
        echo '</ul>'."\n";
     }
     echo '  </td>';
     echo '</tr>'."\n";
  }

  if (mosBookmarksTools::isColVisible( 'rating', $params->columns, 'detail' ) && $params->canvote) {
     echo '  <tr valign="top">';
     if ($params->detailshowtitles) {
        echo '<td nowrap="nowrap"><b>'. _BMU_RATING. '</b>&nbsp;:&nbsp;</td>';
     }
     echo '<td>';

     // ** retrieve column "Rating"
     $column = array();
     for ($i=0; $i<count($params->columns); $i++) {
       $col = &$params->columns[$i];
       if ( $col->name == 'rating' ) {
         $column = $col;
       }
     }

     if ( ($params->canvotedetail == 1 || $params->canvotedetail == 2) && $my->gid >= $params->votelevel) {
        echo mosBookmarksTools::displayRating ('rating', $row, $column, $params, true, 3, $lists->rating);
     } else {
        echo mosBookmarksTools::displayRating ('rating', $row, $column, $params, true, 2);
     }

     echo '</td>';
     echo '</tr>';
  }

  if (mosBookmarksTools::isColVisible( 'hits', $params->columns, 'detail' )) {
     echo '  <tr valign="top">';
     if ($params->detailshowtitles) {
        echo '<td nowrap="nowrap"><b>'. _BMU_HITS. '</b>&nbsp;:&nbsp;</td>';
     }
     echo '<td>'. number_format($row->hits, 0, _BMU_FMT_DECIMAL, _BMU_FMT_THOUSAND). '</td>';
     echo '</tr>';
  }

  if (mosBookmarksTools::isColVisible( 'created', $params->columns, 'detail' )) {
     echo '    <tr valign="top">';
     if ($params->detailshowtitles) {
        echo '<td nowrap="nowrap"><b>'. _BMU_DATE. '</b>&nbsp;:&nbsp;</td>';
     }
     echo '<td>'. JHTML::_('date', $row->created, JText::_('DATE_FORMAT_LC3')). ' / '. JHTML::_('date', $row->modified, JText::_('DATE_FORMAT_LC3')). '</td>';
     echo '</tr>';
  }

  if (mosBookmarksTools::isColVisible( 'created_by', $params->columns, 'detail' )) {
     echo '  <tr valign="top">';
     if ($params->detailshowtitles) {
        echo '<td nowrap="nowrap"><b>'. _BMU_PUBLISHER. '</b>&nbsp;:&nbsp;</td>';
     }
     echo '<td>'. $row->username. '';
     if ($row->private && $params->markprivate && $params->allowprivate) {
        echo '&nbsp;<span style="color: Red; font-weight: bold;" title="' ._BMU_PRIVATE. ' : '.$row->username.'">'._BMU_PRIVATE_MARK.'</span>&nbsp;';
     }
     echo '</td>';
     echo '</tr>'."\n";
  }

  // Custom fields
  foreach ($params->columns as $column) {


    if ($column->custom) {
       $name = 'f_'.$column->name;
       if (mosBookmarksTools::isColVisible( $name, $params->columns, 'detail' )) {
          if ( ($row->$name && $column->f_type != 8) || ($params->canvote && $column->f_type == 8) || $column->f_type == 4 ) {
             echo '  <tr valign="top">';
             if ($params->detailshowtitles) {
                echo '<td nowrap="nowrap"><b>'. $column->title. '</b>&nbsp;:&nbsp;</td>';
             }
             echo '<td>';
             if (($params->canvotedetail == 1 || $params->canvotedetail == 2) && $my->gid >= $params->votelevel && $column->f_type == 8) {  // RATE type & User can vote in Detail page
                echo mosBookmarksTools::displayCustom ($name, $row, $column, $params, true, 3, $lists->$name);
             } else {
                echo mosBookmarksTools::displayCustom ($name, $row, $column, $params, true, 2);
             }

             echo '</td>';
             echo '</tr>'."\n";
          }
       }
    }
  }

  if ( $row->url && ($params->showpagerank == 2 || $params->showpagerank == 3) && $row->pagerank != -1) {
     echo '  <tr valign="top">';
     if ($params->detailshowtitles) {
        echo '<td nowrap="nowrap"><b>'. _BMU_PAGERANK. '</b>&nbsp;:&nbsp;</td>';
     }
     echo '<td>';
     $rank_img = JURI::root(). 'components/com_bookmarks/images/gpr'. $row->pagerank .'.png';
     echo '<img src="' .$rank_img. '" border="0" title="'._BMU_PAGERANK.': '.$row->pagerank.'" alt="PR'.$row->pagerank.'" />';
     echo '</td>';
     echo '</tr>'."\n";

  }

  // *** Display HaloScan comment system : www.haloscan.com
  if ($ishaloscan) {
     echo '  <tr valign="top">';
     if ($params->detailshowtitles) {
        echo '<td nowrap="nowrap"><b>'. _BMU_COMMENTS. '</b>&nbsp;:&nbsp;</td>';
     }
     echo '<td>';
     echo '<a href="javascript:HaloScan(\''.$params->haloscanprefix.$row->id.'\');" target="_self"><script type="text/javascript">postCount(\''.$params->haloscanprefix.$row->id.'\');</script></a>';
     echo '</td>';
     echo '</tr>'."\n";
  }


  echo '</table>'."\n";
  echo '</td>'."\n";

  if ( $params->detailads ) {
     echo '    <!-- Detail Ads (2nd column) -->'."\n";
     echo '<td '.mosBookmarksTools::cssClass($params->cssdetailads).' width="' .$params->detailadswidth. '" nowrap="nowrap">';
     echo $params->detailads;
     echo '</td>'."\n";
  }

  echo '</tr>'."\n";

  // *** Display JomComment comments system : [www.azrul.com]
  if ( $params->jomcomment                                         // is JomComment Support enabled ?
    && file_exists(JPATH_PLUGINS. DS .'content'.DS.'jom_comment_bot.php')   // JomComment Bot installed
    && file_exists(JPATH_SITE.'/components/com_jomcomment/jomcomment.php')  // JomCOmment Component installed
  ) {
     echo '  <!-- BM: JomComment Zone - Start -->'."\n";
     include_once(JPATH_PLUGINS. DS .'content'.DS.'jom_comment_bot.php');    // Load JomComment routines
     echo '<tr>'."\n";
     if ( $params->detailads ) {
        echo '  <td colspan=2>'."\n";
     } else {
        echo '  <td>'."\n";
     }
     echo jomcomment($row->id, "com_bookmarks");     // Display the associated Comments
     echo '  </td>'."\n";
     echo '</tr>'."\n";
     echo '  <!-- BM: JomComment Zone - End -->'."\n";
  }

  // *** Display JReviews system : [www.reviewsforjoomla.com]
  if ( $params->jreviews && defined('_BOOKMARKS_JREVIEWS')      // JReviews Library loaded
  ) {
     echo '  <!-- BM: JReviews Zone - Start -->'."\n";
     echo '<tr>'."\n";
     if ( $params->detailads ) {
        echo '  <td colspan=2>'."\n";
     } else {
        echo '  <td>'."\n";
     }
     $reviews = new jReviewsEverywhere();                       // Create JReviews Object
     $reviews->getReviews($row->id, $catid, 'com_bookmarks');   // Retreives Review for Current Bookmark ID
     echo $reviews->reviews_page;                               // Display Review
     echo '  </td>'."\n";
     echo '</tr>'."\n";
     echo '  <!-- BM: JReviews Zone - End -->'."\n";
  }

  echo '</table>'."\n";

  echo '<table cellpadding="0" cellspacing="0" border="0" width="100%" class="adminform">'."\n";
    //jcomments
    global $mainframe;
    $comments = $mainframe->getCfg('absolute_path') . '/components/com_jcomments/jcomments.php';
    if (file_exists($comments)) {
      require_once($comments);
 
      echo '<tr>'."\n";
      if ( $params->detailads ) {
            echo '  <td colspan=2>'."\n";
      } else {
            echo '  <td>'."\n";
      }
 
      echo JComments::showComments($row->id, 'com_bookmarks', $row->title);
 
      echo '  </td>'."\n";
      echo '</tr>'."\n";
    }
   //jcommentsende
  echo '  <!-- Back Button -->'."\n";
  echo '  <tr><td align="center"><br /><span class="back_button"><a href="'. JRoute::_("index.php?option=$option&Itemid=$Itemid&catid=$catid&navstart=".$params->navstart."&mode=$mode&search=$search").'"><b>'. _BACK. '</b></a></span></td></tr>'."\n";

  HTML_bookmarks::_footer();

  if ( isset($params->showsnapshoterpic) && $params->showsnapshoterpic ) {
     echo '  <!-- Snapshot Free Service Advertising -->'."\n";
     echo '  <tr><td>'.$snaps->systems[$params->snapshotactiv]->PIC_URL.'</td></tr>'."\n";
  }

  echo '</table>'."\n";

  echo "\n".'<!-- ### END Component : Bookmarks (c) www.TEGDesign.ch '.mosBookmarks::getVersion().' ### -->'."\n\n";

}


// ************************
// ***   OPEN WRAPPER   ***
// ************************

/**
* Open Link in a wrapper
*
* A new record is defined when <var>$row</var> is passed with the <var>id</var>
* property set to 0.
* @param mosBookmark The bookmark object
* @param string The html for the categories select list
* @param string The html for the ordering select list
*/
   function wrapperBookmark ( &$row, $option, &$lists, $catid, $Itemid, $mode, $search, $access, $navstart, &$params ) {
       global $mainframe;
       $my =& JFactory::getUser();

       echo "\n".'<!-- ### START Component : Bookmarks (c) www.TEGDesign.ch '.mosBookmarks::getVersion().' ### -->'."\n\n";

       // MosBot : Convert "$params" to "JParameter" format
       $prms = "";
       $bmparams =& new JParameter( $prms );   // Use "$botparms" to avoid overwritting "$params" (from Module)
       foreach ($params as $k=>$v) {
          $bmparams->def($k,$v);
       }
?>

        <table cellpadding="4" cellspacing="0" border="0" width="100%">

          <!-- Page Title -->
          <tr><td width="100%"><span class="contentheading"><?php echo _BMU_BOOKMARK; ?> : <?php echo htmlspecialchars($row->title, ENT_NOQUOTES) ?></span></td></tr>

<?php
          echo '          <!-- Component Header -->'."\n";
          if ($params->comheaderwrapper) {
             if ($params->comheaderwrapper && $params->botsonheaderwrapper) {
                // *** Init MosBots (loading "Content" related bots)
                // *** MosBot : The {MosImage} is no supported as the Images field is not present !!! => Need to use fixed path for images...
                $row->images = "";                      // MosBot Need to simulate "images" field (must be present, but keep empty)
                $row->sectionid = "";                   // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
                $page = 0;                              // MosBot pagination system
                //$_MAMBOTS->loadBotGroup( 'content' );   // Load published Bots from "Content" folder
                JPluginHelper::importPlugin( 'content' );   // Load published Bots from "Content" folder
                // *** Process the MosBots
                $row->text = $params->comheaderwrapper;  // MosBot only uses field "text" => Need to copy "detail" content ...
                //$results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
                $results =  $mainframe->triggerEvent( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
                $params->comheaderwrapper = $row->text;
             }
             echo '          <tr><td><div class="contentpane">';
             echo $params->comheaderwrapper;
             echo '</td></tr></div>'."\n";
          }
?>

          <!-- Back Button -->
          <tr><td align="center"><span class="back_button"><a href="javascript:window.history.go(-1);"><b><?php echo _BACK; ?></b></a></span><br /></td></tr>

          <!-- Open Wrapper -->
          <tr>
            <td width="100%">
               <iframe src="<?php echo $row->url; ?>" scrolling="AUTO"
               frameborder="<?php echo $params->wrapperborder; ?>"
               style="
                  Height: <?php echo $params->wrapperheight; ?><?php echo (substr($params->wrapperheight, -1, 1)!="%") ? "px" : "" ?>;
                  Width: <?php echo $params->wrapperwidth; ?><?php echo (substr($params->wrapperwidth, -1, 1)!="%") ? "px" : "" ?>;
                  Margin: 0pt;
                  Padding: <?php echo $params->wrappermargin; ?>pt;
                  Border: <?php echo $params->wrapperborder; ?>pt;
                  Border-Color: Black;
                  Border-Style: Solid;
                  Display: Block;
               "
               ></iframe>
            </td>
          </tr>

          <!-- Back Button -->
          <tr><td align="center"><span class="back_button"><a href="javascript:window.history.go(-1);"><b><?php echo _BACK; ?></b></a></span><br /></td></tr>

<?php
        HTML_bookmarks::_footer(2);
?>
        </table>

<?php

    echo "\n".'<!-- ### END Component : Bookmarks (c) www.TEGDesign.ch '.mosBookmarks::getVersion().' ### -->'."\n\n";

    }



// ************************
// *** RECOMMEND LINK   ***
// ************************

/**
* Recommend link to a Friend => Ask for Contact information to be able to send the URL
*
* A new record is defined when <var>$row</var> is passed with the <var>id</var>
* property set to 0.
* @param mosBookmark The bookmark object
* @param string The html for the categories select list
* @param string The html for the ordering select list
*/
   function recommendBookmark ( &$row, $option, &$lists, $catid, $Itemid, $mode, $search, $access, $navstart, &$params ) {
        $my =& JFactory::getUser();
        global $mainframe;

        echo "\n".'<!-- ### START Component : Bookmarks (c) www.TEGDesign.ch '.mosBookmarks::getVersion().' ### -->'."\n\n";

        JFilterOutput::objectHTMLSafe( $row );

        if ( $my->id == 0 ) {   // *** Load default functions
          echo '        <script language="javascript" type="text/javascript" src="' .JUri::base(true). '/includes/js/joomla.javascript.js"></script>'."\n";
        }
?>

        <script language="javascript" type="text/javascript">
        function submitbutton(pressbutton) {
            var form = document.adminForm;

            if (pressbutton == 'cancel') {
                submitform( pressbutton );
                return;
            }

            // *** validate mail address
            var mail = form.mailaddress.value;
//            var pattern=/^[a-zA-Z0-9_\-.]+@[a-zA-Z0-9\-]{2,}[.][a-zA-Z]{2,3}$/;
            var pattern=/^[a-zA-Z0-9_\-.]+@[a-zA-Z0-9\-]{2,}[.][a-zA-Z]{2,3}[.][a-zA-Z]{2}$|^[a-zA-Z0-9_\-.]+@[a-zA-Z0-9\-]{2,}[.][a-zA-Z]{2,3}$/;
            valid = pattern.test(mail);

            // *** Do fields validation
            if (!valid){  // mail format not valid...
                alert( "<?php echo _BM_CONTACT_MUST_HAVE_ADDRESS; ?>" );
            } else {
                submitform( pressbutton );
            }
        }
        </script>

        <table cellpadding="4" cellspacing="0" border="0" width="100%">
          <tr>
            <!-- Page Title -->
            <td width="100%"><span class="contentheading"><?php echo _BM_RECOMMEND_TO_FRIEND; ?></span></td>
          </tr>

            <!-- Actions -->
          <tr>
              <td width="50%">
		<div style="float: right;">
<?php             if ($params->returntask == 'detail') { ?>
			<button type="button" onclick="submitbutton('sendd')"><?php echo _BMU_SENDMAIL; ?></button>
<?php             } else { ?>
			<button type="button" onclick="submitbutton('send')"><?php echo _BMU_SENDMAIL; ?></button>
<?php             } ?>
			<button type="button" onclick="submitbutton('cancel')"><?php echo _BMU_CANCEL; ?></button>
		</div>

<?php
/*

            // *** Action Buttons
            JLoader::register('JToolbarHelper' , JPATH_ADMINISTRATOR.DS.'includes'.DS.'toolbar.php');
            jimport('joomla.html.toolbar');    // Import Toolbar library
?>
            <style type="text/css">
            .icon-32-send     { background-image: url(/components/com_bookmarks/images/send.png); padding: 8pt;}
            .icon-32-cancel   { background-image: url(images/cancel.png); }
            </style>
<?php
            // Get the JComponent instance of JToolBar
            $bar = & JToolBar::getInstance('toolbar');

            JToolBarHelper::title( _BM_BOOKMARKS, 'logo' );
            if ($params->returntask == 'detail') {
               JToolBarHelper::custom( 'sendd', 'send.png', 'send_f2.png', 'Send Mail', true );
            } else {
               JToolBarHelper::custom( 'send', 'send.png', 'send_f2.png', 'Send Mail', false );
            }
            JToolBarHelper::spacer();
            JToolBarHelper::cancel();
            // Render the toolbar
            echo $bar->render('toolbar');
*/
?>
            </td>
          </tr>
        </table>

        <!-- Form -->
        <form action="<?php echo JRoute::_("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&navstart=$navstart&search=$search"); ?>" method="post" name="adminForm" id="adminForm">

        <table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminform">

<?php if (!$my->id) { ?>
            <tr valign="top">
                <td nowrap="nowrap" align="right"><?php echo _BMU_USERNAME; ?>:</td>
                <td>
                    <input class="inputbox" type="text" id="mailusername" name="mailusername" value="" size="30" maxlength="50" />
                </td>
            </tr>

<?php } ?>
            <tr valign="top">
                <td width="100" nowrap="nowrap" align="right"><?php echo _BM_TITLE; ?>:</td>
                <td>
                    <?php echo htmlspecialchars($row->title, ENT_NOQUOTES); ?>
                </td>
            </tr>

            <tr valign="top">
                <td nowrap="nowrap" align="right"><?php echo _BM_URL; ?>:</td>
                <td>
                    <?php echo $row->url; ?>
                </td>
            </tr>

            <tr valign="top">
                <td nowrap="nowrap" align="right"><?php echo _BMU_MAIL; ?>:</td>
                <td>
                    <input class="inputbox" type="text" id="mailaddress" name="mailaddress" value="" size="50" maxlength="100" />
                </td>
            </tr>

<?php if ($my->id) { ?>
            <tr valign="top">
                <td nowrap="nowrap" align="right"><?php echo _BMU_COMMENT; ?>:</td>
                <td>
                    <textarea id="mailcomment" name="mailcomment" cols="25" rows="5"></textarea>
                </td>
            </tr>

<?php } ?>
        </table>

        <input type="hidden" name="option" value="<?php echo $option;?>" />
        <input type="hidden" name="id" value="<?php echo $row->id; ?>" />
        <input type="hidden" name="catid" value="<?php echo $catid; ?>" />
        <input type="hidden" name="Itemid" value="<?php echo $Itemid; ?>" />
        <input type="hidden" name="task" value="" />
        <?php echo JHTML::_( 'form.token' ); ?>
      </form>

      <table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminform">

          <!-- Back Button -->
          <tr><td align="center"><span class="back_button"><a href="javascript:window.history.go(-1);"><b><?php echo _BACK; ?></b></a></span><br /></td></tr>
<?php
      HTML_bookmarks::_footer(2);
?>
      </table>

<?php

    echo "\n".'<!-- ### END Component : Bookmarks (c) www.TEGDesign.ch '.mosBookmarks::getVersion().' ### -->'."\n\n";

    }


} // end class
?>
